#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"




void affichage_map(Map *map,General *general)
{
	char i,j,x,y,camera_x,camera_y,regard,sprite_8[]={0,24,24,24,24,24,24,0};
	Etre etre;
	
	if(!general->zoom)
	{
		for(i=0;i<LARGEUR;i++)
		{
			for(j=0;j<HAUTEUR;j++)
			{
				if(MAP(i,j)==REMPART)affichage_rempart(i,j,FAUX,map->etres[2].blessure>0);
				else if(MAP(i,j)==LEURRE)affichage_etre_8(EDASTHEREBE,i,j,3,0,map->etres[1].blessure>0);
				else if(MAP(i,j)==SOURCE_ETHER)affichage_source_ether(i,j,FAUX);
				else if(MAP(i,j)==SOURCE_DIVINE)affichage_source_divine(i,j,FAUX);
				else if(MAP(i,j)==LARME)affichage_larme(i,j,FAUX);
				else if(MAP(i,j))affichage_element_8(MAP(i,j),i,j);
				
				if(MAP_FUMEE(i,j))affichage_carre(i,j,ML_CHECKER,FAUX);
				if(general->etape>=2)if(general->pouvoirs_choisis[RESIDUELLE]->id==DEFLAGRATION && DISTANCE(general->x_source,general->y_source,i,j)<=3 && MAP(i,j)!=ETRE && (i!=general->x || j!=general->y))affichage_carre(i,j,ML_XOR,FAUX);
			}
		}
		
		if(general->alternance && !general->sortie)affichage_etre_8(EDASTHEREBE,general->x,general->y,general->direction,general->fugace,general->blessure>0);
		if(general->etape==1)affichage_cible(general->x_source,general->y_source);
	}
	else
	{
		camera_x=general->x-3;
		camera_y=general->y-2+general->regard;
		
		if(camera_x<0)camera_x=0;
		if(camera_x>LARGEUR-7)camera_x=LARGEUR-7;
		if(camera_y<0)camera_y=0;
		if(camera_y>HAUTEUR-4)camera_y=HAUTEUR-4;
		
		for(i=camera_x;i<=camera_x+6 && i<LARGEUR;i++)
		{
			for(j=camera_y;j<=camera_y+3 && j<HAUTEUR;j++)
			{
				x=(i-camera_x>=0?i-camera_x:0);
				y=(j-camera_y>=0?j-camera_y:0);
				
				if(MAP(i,j)==REMPART)affichage_rempart(x,y,VRAI,map->etres[2].blessure>0);
				else if(MAP(i,j)==LEURRE)affichage_etre_16(EDASTHEREBE,x,y,3,0,map->etres[1].blessure);
				else if(MAP(i,j)==SOURCE_ETHER)affichage_source_ether(x,y,VRAI);
				else if(MAP(i,j)==SOURCE_DIVINE)affichage_source_divine(x,y,VRAI);
				else if(MAP(i,j)==LARME)affichage_larme(x,y,VRAI);
				else if(MAP(i,j))affichage_element_16(MAP(i,j),x,y);
				
				if(MAP_FUMEE(i,j))affichage_carre(x,y,ML_CHECKER,VRAI);
			}
		}
		
		if(general->alternance && !general->sortie)affichage_etre_16(EDASTHEREBE,general->x-camera_x,general->y-camera_y,general->direction,general->fugace,general->blessure>0);
	}

	for(i=3;i<map->nombre_etres;i++)
	{
		etre=map->etres[i];
		if(etre.vivant)
		{
			x=etre.x;
			y=etre.y;
			if(general->zoom)
			{
				regard=general->regard-(general->regard && general->y==6)+(!general->regard && general->y==1);
				if(x>=camera_x && x<=camera_x+6 && y>=camera_y && y<=camera_y+3)affichage_etre_16(etre.type,x-camera_x,y-camera_y,etre.direction,etre.mode,etre.blessure>0);
			}
			else affichage_etre_8(etre.type,x,y,etre.direction,etre.mode,etre.blessure>0);
		}
	}
	
	if(general->etape>=2)
	{
		if(general->pouvoirs_choisis[RESIDUELLE]->id!=DEFLAGRATION)affichage_carre(general->x_source,general->y_source,ML_XOR,FAUX);
		if(general->cible)ML_line(8*general->cible->x+4,8*general->cible->y+4,8*general->x_source+4,8*general->y_source+4,ML_BLACK);
		if(general->pouvoirs_choisis[RESIDUELLE]->id==RESSOURCEMENT)ML_horizontal_line(8*general->y-1+((general->etape-2)/2),8*general->x,8*general->x+7,ML_XOR);
	}
}

void affichage_barres_pouvoir(Pouvoir *pouvoirs_choisis[6])
{
	//Largeur des barres de pouvoir : 13 pixels
	char chaine[]="F ",i,largeur;
	Pouvoir *pouvoir;
	
	for(i=0;i<6;i++)
	{
		pouvoir=pouvoirs_choisis[i];
		if(pouvoir)
		{
			chaine[1]='1'+i;
			PrintMini(117,3+10*i,CUC chaine,1);
			
			if(pouvoir->etat==RECHARGEMENT)largeur=(((pouvoir->rechargement*1000)/pouvoir->temps_rechargement)*13)/1000;
			else largeur=(((pouvoir->utilisation*1000)/pouvoir->temps_utilisation)*13)/1000;
			
			ML_horizontal_line(1+10*i,114,126,ML_BLACK);
			ML_vertical_line(113,2+10*i,8+10*i,ML_BLACK);
			ML_vertical_line(127,2+10*i,8+10*i,ML_BLACK);
			ML_horizontal_line(9+10*i,114,126,ML_BLACK);
			
			if(largeur)ML_rectangle(114,2+10*i,113+largeur,8+10*i,0,0,ML_XOR);
		}
	}
}

void recapitulatif(Pouvoir *pouvoirs_choisis[6],short vie)
{
	//Largeur de la barre de vie : 81 pixels

	char i,chaine[]="[F ] :",largeur=(((vie*1000)/VIE_MAX)*81)/1000;

	while(IsKeyDown(KEY_CTRL_OPTN))
	{
		PopUpWin(6);
		
		PrintMini(29,5,CUC ">>>Recapitulatif<<<",1);
		PrintMini(11,14,CUC "Vie :",1);
		
		ML_vertical_line(31,15,17,ML_BLACK);
		ML_horizontal_line(14,32,112,ML_BLACK);
		ML_horizontal_line(18,32,112,ML_BLACK);
		ML_vertical_line(113,15,17,ML_BLACK);
		if(vie)ML_rectangle(32,15,32+largeur,17,0,0,ML_BLACK);
		
		for(i=0;i<6;i++)
		{
			chaine[2]='1'+i;
			PrintMini(11,23+6*i,CUC chaine,1);
			if(pouvoirs_choisis[i])PrintMini(36,23+6*i,CUC pouvoirs_choisis[i]->nom,1);
		}
		
		ML_display_vram();
		
		i=categorie_pouvoir();
		if(i>-1 && pouvoirs_choisis[i])informations(pouvoirs_choisis[i]);
		
		Sleep(100);
	}
}

void affichage_element_8(Obstacle obstacle,char x,char y)
{
	char bitmap_statue[]={0x18, 0xbd, 0x99, 0x7e, 0x18, 0x18, 0x3c, 0x7e},
		 bitmap_tabouret[]={0x0, 0x0, 0x70, 0x50, 0x50, 0xe7, 0xa4, 0xa7},
		 bitmap_armes[]={0x80, 0x50, 0x20, 0x50, 0x8, 0x3c, 0x2a, 0x29},
		 bitmap_coffre[]={0x0, 0x38, 0x44, 0xba, 0xee, 0xba, 0x82, 0xfe},
		 bitmap_grille_cote[]={0x10, 0x38, 0x10, 0x10, 0x10, 0x10, 0x38, 0x10},
		 bitmap_grille_face[]={0xaa, 0xff, 0xaa, 0xab, 0xab, 0xaa, 0xff, 0xaa},
	
		 bitmap_mur1[]={0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3, 0xc3},
		 bitmap_mur1_extremite[]={0xff,0xff,0xc3,0xc3,0xc3,0xc3,0xc3,0xc3},
		 bitmap_mur1_face[]={0xff, 0xff, 0x22, 0xff, 0x44, 0xff, 0x11, 0xff},
		 bitmap_porte1_droite[]={0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43},
		 bitmap_porte1_gauche[]={0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2, 0xc2},
		 bitmap_porte1_face[]={0xff, 0x81, 0x3c, 0xbd, 0x3c, 0xbd, 0x3d, 0xbd},
		 bitmap_pilier1[]={0x3c, 0x42, 0x7e, 0x46, 0x7e, 0x52, 0x7e, 0x4a},
		 bitmap_double_porte1_gauche[]={0xff, 0x80, 0x3e, 0xbe, 0x3a, 0xbe, 0x3e, 0xbe},
		 bitmap_double_porte1_droite[]={0xff, 0x1, 0x7c, 0x7d, 0x5c, 0x7d, 0x7d, 0x7d},
		 
		 bitmap_mur2[]={0x81, 0xbd, 0xa5, 0xa5, 0xa5, 0xa5, 0xbd, 0x81},
		 bitmap_mur2_extremite[]={0xff, 0x81, 0xbd, 0xa5, 0xa5, 0xa5, 0xbd, 0x81},
		 bitmap_mur2_face[]={0xff, 0x81, 0xbd, 0xa5, 0xad, 0xa1, 0x81, 0xff},
		 bitmap_porte2_droite[]={0x41, 0x5d, 0x55, 0x55, 0x55, 0x55, 0x5d, 0x41},
		 bitmap_porte2_gauche[]={0x82, 0xba, 0xaa, 0xaa, 0xaa, 0xaa, 0xba, 0x82},
		 bitmap_porte2_face[]={0xff, 0x42, 0xbd, 0xbd, 0xbd, 0xbd, 0xbd, 0xbd},
		 bitmap_pilier2[]={0x3c, 0x42, 0x7e, 0x7e, 0x7e, 0x7e, 0x7e, 0x3c},

		 bitmap_mur3_face[]={0xff, 0x24, 0x38, 0xc6, 0x23, 0x5c, 0x92, 0xff},
		 bitmap_porte3_face[]={0xff, 0x44, 0x29, 0xbc, 0x7e, 0x7f, 0xfe, 0xff},
		 bitmap_pilier3[]={0x3c, 0x7e, 0x52, 0x52, 0x7e, 0x4a, 0x4a, 0x7e};
	char *sprite=NULL;
	
	switch(obstacle)
	{
		case STATUE_FACE: sprite=bitmap_statue;
		Bcase(STATUE_DOS) sprite=bitmap_statue;
		Bcase(TABOURET) sprite=bitmap_tabouret;
		Bcase(ARMES) sprite=bitmap_armes;
		Bcase(COFFRE) sprite=bitmap_coffre;
		Bcase(GRILLE_FACE)sprite=bitmap_grille_face;
		Bcase(GRILLE_COTE)sprite=bitmap_grille_cote;		
		
		Bcase(MUR1) sprite=bitmap_mur1;
		Bcase(MUR1_EXTREMITE) sprite=bitmap_mur1_extremite;
		Bcase(MUR1_FACE) sprite=bitmap_mur1_face;
		Bcase(PORTE1_DROITE)sprite=bitmap_porte1_droite;
		Bcase(PORTE1_GAUCHE)sprite=bitmap_porte1_gauche;
		Bcase(PORTE1_FACE)sprite=bitmap_porte1_face;
		Bcase(PILIER1)sprite=bitmap_pilier1;
		Bcase(DOUBLE_PORTE1_GAUCHE)sprite=bitmap_double_porte1_gauche;
		Bcase(DOUBLE_PORTE1_DROITE)sprite=bitmap_double_porte1_droite;
		
		Bcase(MUR2) sprite=bitmap_mur2;
		Bcase(MUR2_EXTREMITE) sprite=bitmap_mur2_extremite;
		Bcase(MUR2_FACE) sprite=bitmap_mur2_face;
		Bcase(FAUSSE_PORTE2_DROITE)sprite=bitmap_porte2_droite;
		Bcase(PORTE2_DROITE)sprite=bitmap_porte2_droite;
		Bcase(PORTE2_GAUCHE)sprite=bitmap_porte2_gauche;
		Bcase(PORTE2_FACE)sprite=bitmap_porte2_face;
		Bcase(PILIER2)sprite=bitmap_pilier2;
		
		Bcase(MUR3) sprite=bitmap_mur1;
		Bcase(MUR3_EXTREMITE) sprite=bitmap_mur1_extremite;
		Bcase(MUR3_FACE) sprite=bitmap_mur3_face;
		Bcase(PORTE3_DROITE)sprite=bitmap_porte1_droite;
		Bcase(PORTE3_GAUCHE)sprite=bitmap_porte1_gauche;
		Bcase(PORTE3_FACE)sprite=bitmap_porte3_face;
		Bcase(PILIER3)sprite=bitmap_pilier3;
		break;
	}
	
	if(sprite)ML_bmp_8_or(CUC sprite,8*x,8*y);
}

void affichage_element_16(Obstacle obstacle,char x,char y)
{
	char bitmap_statue_face[]={0x0, 0x0, 0x7, 0xe0, 0xa9, 0x95, 0xaf, 0xf5, 0x67, 0xe6, 0x63, 0xc6, 0x7e, 0x7e, 0x3f, 0xfc, 0x2, 0x40, 0x3, 0xc0, 0x2, 0x40, 0x3, 0xc0, 0x3, 0xc0, 0x7, 0xe0, 0xf, 0xf0, 0x1f, 0xf8},
		 bitmap_statue_dos[]={0x0, 0x0, 0x7, 0xe0, 0xaf, 0xf5, 0xaf, 0xf5, 0x67, 0xe6, 0x63, 0xc6, 0x7f, 0xfe, 0x3f, 0xfc, 0x3, 0xc0, 0x3, 0xc0, 0x3, 0xc0, 0x3, 0xc0, 0x3, 0xc0, 0x7, 0xe0, 0xf, 0xf0, 0x1f, 0xf8},
		 bitmap_tabouret[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3e, 0x0, 0x36, 0x0, 0x22, 0x0, 0x36, 0x0, 0x36, 0x0, 0xff, 0x80, 0x80, 0xbe, 0xff, 0xb6, 0x55, 0x20, 0xa2, 0xb6, 0xc1, 0xbe},
		 bitmap_armes[]={0x0, 0x0, 0x0, 0x0, 0x40, 0x0, 0x22, 0x0, 0x14, 0x0, 0xc, 0x0, 0x1a, 0x0, 0x25, 0x0, 0x2, 0x80, 0x1, 0x40, 0x1f, 0xa0, 0x1b, 0x50, 0x11, 0x28, 0x7b, 0xfc, 0x9b, 0xf, 0x7f, 0xfe},
		 bitmap_coffre[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1f, 0xf0, 0x20, 0x8, 0x40, 0x4, 0x43, 0x84, 0x46, 0xc4, 0x7c, 0x7c, 0x46, 0xc4, 0x43, 0x84, 0x40, 0x4, 0x40, 0x4, 0x40, 0x4, 0x40, 0x4, 0x7f, 0xfc},
		 bitmap_grille_cote[]={0x1, 0x0, 0x3, 0x80, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x1, 0x0, 0x3, 0x80, 0x1, 0x0},
		 bitmap_grille_face[]={0xa4, 0x92, 0xff, 0xff, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x93, 0xa4, 0x93, 0xa4, 0x93, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x92, 0xa4, 0x92, 0xff, 0xff, 0xa4, 0x92},
		 
  		 bitmap_mur1[]={0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7},
		 bitmap_mur1_extremite[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7, 0xe0, 0x7},
		 bitmap_mur1_face[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0x22, 0x10, 0x22, 0xff, 0xff, 0x4, 0x41, 0x4, 0x41, 0xff, 0xff, 0x20, 0x82, 0x20, 0x82, 0xff, 0xff, 0x9, 0x10, 0x9, 0x10, 0xff, 0xff, 0xff, 0xff},
		 bitmap_porte1_gauche[]={0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4, 0xe0, 0x4},
		 bitmap_porte1_droite[]={0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7, 0x20, 0x7},
		 bitmap_porte1_face[]={0xff, 0xff, 0xc0, 0x3, 0xc0, 0x3, 0x7f, 0xfe, 0x5f, 0xfa, 0xdf, 0xfb, 0x5f, 0xfa, 0x5f, 0xfa, 0xdf, 0xfb, 0x5f, 0xfa, 0x5f, 0xfa, 0xdf, 0xfb, 0x5f, 0xfa, 0x5f, 0xfa, 0xdf, 0xfb, 0xdf, 0xfb},
		 bitmap_pilier1[]={0xf, 0xf0, 0x10, 0x8, 0x20, 0x4, 0x3f, 0xfc, 0x3f, 0xfc, 0x0, 0x0, 0x36, 0xe8, 0x36, 0xe8, 0x0, 0x0, 0x3b, 0xdc, 0x3b, 0xdc, 0x0, 0x0, 0x2f, 0x74, 0x2f, 0x74, 0x0, 0x0, 0x3f, 0xfc},
		 bitmap_double_porte1_gauche[]={0xff, 0xff, 0xe0, 0x0, 0xe0, 0x0, 0x3f, 0xff, 0x28, 0x1, 0xe8, 0x1, 0x28, 0x1, 0x28, 0x1, 0xe8, 0x21, 0x28, 0x51, 0x28, 0x21, 0xe8, 0x1, 0x28, 0x1, 0x28, 0x1, 0xe8, 0x1, 0xe8, 0x1},
		 bitmap_double_porte1_droite[]={0xff, 0xff, 0x0, 0x3, 0x0, 0x3, 0xff, 0xfe, 0x80, 0x16, 0x80, 0x17, 0x80, 0x15, 0x80, 0x15, 0x84, 0x17, 0x8a, 0x16, 0x84, 0x16, 0x80, 0x17, 0x80, 0x14, 0x80, 0x14, 0x80, 0x17, 0x80, 0x17},
		
		 bitmap_mur2[]={0xc0, 0x3, 0xdf, 0xfb, 0xd0, 0xb, 0xd7, 0xeb, 0xd4, 0x2b, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd4, 0x2b, 0xd7, 0xeb, 0xd0, 0xb, 0xdf, 0xfb, 0xc0, 0x3},
		 bitmap_mur2_extremite[]={0xff, 0xff, 0xff, 0xff, 0xc0, 0x3, 0xdf, 0xfb, 0xd0, 0xb, 0xd7, 0xeb, 0xd4, 0x2b, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd4, 0x2b, 0xd7, 0xeb, 0xd0, 0xb, 0xdf, 0xfb, 0xc0, 0x3},
		 bitmap_mur2_face[]={0xff, 0xff, 0x80, 0x1, 0xbf, 0xfd, 0xa0, 0x5, 0xaf, 0xf5, 0xa8, 0x15, 0xab, 0xd5, 0xaa, 0x55, 0xaa, 0xd5, 0xaa, 0x15, 0xab, 0xf5, 0xa8, 0x5, 0xaf, 0xfd, 0x80, 0x1, 0xff, 0xff, 0xff, 0xff},
		 bitmap_porte2_gauche[]={0xc0, 0x2, 0xdf, 0xfa, 0xd0, 0xa, 0xd7, 0xea, 0xd4, 0x2a, 0xd5, 0xaa, 0xd5, 0xaa, 0xd5, 0xaa, 0xd5, 0xaa, 0xd5, 0xaa, 0xd5, 0xaa, 0xd4, 0x2a, 0xd7, 0xea, 0xd0, 0xa, 0xdf, 0xfa, 0xc0, 0x2},
		 bitmap_porte2_droite[]={0x40, 0x3, 0x5f, 0xfb, 0x50, 0xb, 0x57, 0xeb, 0x54, 0x2b, 0x55, 0xab, 0x55, 0xab, 0x55, 0xab, 0x55, 0xab, 0x55, 0xab, 0x55, 0xab, 0x54, 0x2b, 0x57, 0xeb, 0x50, 0xb, 0x5f, 0xfb, 0x40, 0x3},
		 bitmap_porte2_face[]={0xff, 0xff, 0xf0, 0xf, 0x10, 0x8, 0x2f, 0xf4, 0x2f, 0xf4, 0x2f, 0xf4, 0x2f, 0xf4, 0x4f, 0xf2, 0x4f, 0xf2, 0x4f, 0xf2, 0x4f, 0xf2, 0x8f, 0xf1, 0x8f, 0xf1, 0x8f, 0xf1, 0x8f, 0xf1, 0xff, 0xff},
		 bitmap_pilier2[]={0xf, 0xf0, 0x10, 0x8, 0x20, 0x4, 0x30, 0xc, 0x3f, 0xf4, 0x2c, 0xfc, 0x35, 0xdc, 0x1f, 0xb8, 0x2f, 0xf4, 0x30, 0xc, 0x3f, 0xfc, 0x31, 0xcc, 0x3b, 0xbc, 0x2e, 0xfc, 0x1f, 0x78, 0xf, 0xf0},
		 
		 bitmap_mur3_face[]={0xff, 0xff, 0xff, 0xff, 0x62, 0x4, 0x12, 0x18, 0xd, 0x20, 0x10, 0xd0, 0xe0, 0x89, 0x21, 0xa, 0x1e, 0x4, 0x13, 0xb8, 0x20, 0x46, 0x58, 0x45, 0xc4, 0xc4, 0x63, 0xa, 0x14, 0xf1, 0xff, 0xff},
		 bitmap_porte3_face[]={0xff, 0xff, 0xff, 0xff, 0x23, 0x44, 0xd5, 0x24, 0x19, 0x38, 0x2b, 0xc4, 0x47, 0xe7, 0xcf, 0xf4, 0x3f, 0xf8, 0x1f, 0xfc, 0x9f, 0xfa, 0x5f, 0xf9, 0x5f, 0xf9, 0x3f, 0xfe, 0x5f, 0xfa, 0xff, 0xff},
		 bitmap_pilier3[]={0xf, 0xf0, 0x1f, 0xf8, 0x3f, 0xfc, 0x1f, 0xf8, 0x2a, 0x5c, 0x26, 0x14, 0x23, 0x14, 0x1f, 0xf8, 0x24, 0x44, 0x35, 0x4c, 0x26, 0x54, 0x1f, 0xf8, 0x23, 0x24, 0x22, 0x64, 0x2a, 0x34, 0x3f, 0xfc};
	char *sprite=NULL;
	
	switch(obstacle)
	{
		case STATUE_FACE: sprite=bitmap_statue_face;
		Bcase(STATUE_DOS) sprite=bitmap_statue_dos;
		Bcase(TABOURET) sprite=bitmap_tabouret;
		Bcase(ARMES) sprite=bitmap_armes;
		Bcase(COFFRE) sprite=bitmap_coffre;
		Bcase(GRILLE_FACE)sprite=bitmap_grille_face;
		Bcase(GRILLE_COTE)sprite=bitmap_grille_cote;	
		
		Bcase(MUR1) sprite=bitmap_mur1;
		Bcase(MUR1_EXTREMITE) sprite=bitmap_mur1_extremite;
		Bcase(MUR1_FACE) sprite=bitmap_mur1_face;
		Bcase(PORTE1_DROITE)sprite=bitmap_porte1_droite;
		Bcase(PORTE1_GAUCHE)sprite=bitmap_porte1_gauche;
		Bcase(PORTE1_FACE)sprite=bitmap_porte1_face;
		Bcase(PILIER1)sprite=bitmap_pilier1;
		Bcase(DOUBLE_PORTE1_GAUCHE)sprite=bitmap_double_porte1_gauche;
		Bcase(DOUBLE_PORTE1_DROITE)sprite=bitmap_double_porte1_droite;
		
		Bcase(MUR2)sprite=bitmap_mur2;
		Bcase(MUR2_EXTREMITE)sprite=bitmap_mur2_extremite;
		Bcase(MUR2_FACE)sprite=bitmap_mur2_face;
		Bcase(FAUSSE_PORTE2_DROITE)sprite=bitmap_porte2_droite;
		Bcase(PORTE2_DROITE)sprite=bitmap_porte2_droite;
		Bcase(PORTE2_GAUCHE)sprite=bitmap_porte2_gauche;
		Bcase(PORTE2_FACE)sprite=bitmap_porte2_face;
		Bcase(PILIER2)sprite=bitmap_pilier2;
		
		Bcase(MUR3) sprite=bitmap_mur1;
		Bcase(MUR3_EXTREMITE) sprite=bitmap_mur1_extremite;
		Bcase(MUR3_FACE) sprite=bitmap_mur3_face;
		Bcase(PORTE3_DROITE)sprite=bitmap_porte1_droite;
		Bcase(PORTE3_GAUCHE)sprite=bitmap_porte1_gauche;
		Bcase(PORTE3_FACE)sprite=bitmap_porte3_face;
		Bcase(PILIER3)sprite=bitmap_pilier3;
		break;
	}
	
	if(sprite)ML_bmp_16_or((const unsigned short*)CUC sprite,16*x,16*y);
}

void affichage_rempart(char x,char y,Bool zoom,Bool degat)
{
	char i,taille=8<<2*zoom;
	char *bitmap=calloc(taille,sizeof(char));
	
	if(degat)
	{
		if(alea(0,1))for(i=0;i<taille;i++)bitmap[i]=255;
	}
	else for(i=0;i<taille;i++)bitmap[i]=alea(0,255);
	
	ML_bmp_or(CUC bitmap,x<<3+zoom,y<<3+zoom,8<<zoom,8<<zoom);
	free(bitmap);
}


void affichage_source_ether(char x,char y,Bool zoom)
{
	char i,j,k,*pointeur,
	bitmap_source_8[]={0x3c, 0x18, 0x3c, 0x5a, 0x7e, 0x81, 0xc3, 0xff},
	bitmap_source_16[]={0x7, 0xe0, 0x9, 0x90, 0xf, 0xf0, 0x7, 0xe0, 0x3, 0xc0, 0x7, 0xe0, 0xf, 0xf0, 0x1b, 0xd8, 0x3b, 0xdc, 0x7f, 0xfe, 0xc0, 0x3, 0x80, 0x1, 0x80, 0x1, 0xc0, 0x3, 0xff, 0xff, 0xff, 0xff};

	if(zoom)
	{
		for(k=0;k<3;k++)
		{
			i=alea(20,26);
			j=alea(i&1+(i==20 || i==26),7-(i&1)-(i==20 || i==26));
			bitmap_source_16[i]|=1<<j;
		}
		
		ML_bmp_16_or((const unsigned short*) bitmap_source_16,x<<4,y<<4);
	}
	else ML_bmp_8_or(CUC bitmap_source_8,x<<3,y<<3);
}

void affichage_source_divine(char x,char y,Bool zoom)
{
	char i,j,k,*pointeur,
	bitmap_source_8[]={0x18, 0x24, 0x66, 0xff, 0xff, 0x81, 0xc3, 0xff},
	bitmap_source_16[]={0x7, 0xe0, 0xf, 0xf0, 0x1e, 0x78, 0x1d, 0xb8, 0x3d, 0xbc, 0x3e, 0x7c, 0x7f, 0xfe, 0x7f, 0xfe, 0x7f, 0xfe, 0xff, 0xff, 0xc0, 0x3, 0x80, 0x1, 0x80, 0x1, 0xc0, 0x3, 0xff, 0xff, 0xff, 0xff};;

	if(zoom)
	{
		for(k=0;k<3;k++)
		{
			i=alea(20,26);
			j=alea(i&1+(i==20 || i==26),7-(i&1)-(i==20 || i==26));
			bitmap_source_16[i]|=1<<j;
		}
		
		ML_bmp_16_or((const unsigned short*) bitmap_source_16,x<<4,y<<4);
	}
	else ML_bmp_8_or(CUC bitmap_source_8,x<<3,y<<3);
}

void affichage_larme(char x,char y,Bool zoom)
{
	char i,j,k,*pointeur,
	bitmap_larme_8[]={0x0, 0x0, 0x10, 0x28, 0x44, 0x44, 0x38, 0x0},
	bitmap_larme_16[]={0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x0, 0x2, 0x80, 0x4, 0x40, 0x8, 0xa0, 0x8, 0xa0, 0x9, 0x20, 0x4, 0x40, 0x3, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0};
	
	if(zoom)
	{
		for(k=0;k<3;k++)
		{
			i=alea(0,31);
			j=alea(0,7);
			bitmap_larme_16[i]|=1<<j;
		}
		
		ML_bmp_16_or((const unsigned short*) bitmap_larme_16,x<<4,y<<4);
	}
	else ML_bmp_8_or(CUC bitmap_larme_8,x<<3,y<<3);
}

void affichage_carre(char x,char y,ML_Color couleur,Bool zoom)
{
	if(zoom) ML_rectangle(16*x,16*y,16*x+15,16*y+15,0,0,couleur);
	else ML_rectangle(8*x,8*y,8*x+7,8*y+7,0,0,couleur);
}

void affichage_cible(char x,char y)
{
	char cible[]={0xe7, 0x81, 0x81, 0x0, 0x0, 0x81, 0x81, 0xe7};
	ML_bmp_8_xor(CUC cible,8*x,8*y);
}

void affichage_etre_8(Type type,char x,char y,char direction,char mode,Bool negatif)
{
	unsigned char Edastherebe[2*4*8]={
										0x38, 0x44, 0x82, 0x82, 0x44, 0x28, 0x10, 0x0,
										0x18, 0x24, 0x4a, 0x42, 0x44, 0x28, 0x10, 0x0,
										0x38, 0x44, 0xaa, 0x82, 0x44, 0x28, 0x10, 0x0,
										0x18, 0x24, 0x52, 0x42, 0x22, 0x14, 0x8, 0x0,
										
										0x0, 0x0, 0x10, 0x28, 0x10, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x10, 0x28, 0x10, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x10, 0x28, 0x10, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x10, 0x28, 0x10, 0x0, 0x0, 0x0
									  },
	Fanatique[2*4*8]={	//Mode statique :
						0x74, 0x74, 0x7e, 0xfc, 0xfc, 0xf4, 0x74, 0x54,
						0x74, 0x64, 0x7e, 0x7c, 0x74, 0x74, 0x64, 0x74,
						0x74, 0x54, 0x7e, 0xfc, 0xfc, 0xf4, 0x74, 0x54,
						0x2e, 0x26, 0x7e, 0x3e, 0x2e, 0x2e, 0x26, 0x2e,
								
						//Mode actif :
						0x71, 0x72, 0x74, 0xf8, 0xf8, 0x70, 0xf0, 0x50,
						0xe1, 0xc2, 0xe4, 0xe8, 0xf0, 0xe0, 0xe0, 0xb0,
						0x71, 0x52, 0x74, 0xf8, 0xf8, 0x70, 0xf0, 0x50,
						0x87, 0x43, 0x27, 0x17, 0xf, 0x7, 0x7, 0xd
					 },
	Pretre[2*4*8]={			 
					//Mode statique :
					0x38, 0x38, 0x38, 0x10, 0x7c, 0x7c, 0x38, 0x38,
					0x8, 0x14, 0x14, 0x8, 0x1c, 0x1c, 0x14, 0x3c,
					0x38, 0x28, 0x28, 0x10, 0x7c, 0x7c, 0x38, 0x38,
					0x10, 0x28, 0x28, 0x10, 0x38, 0x38, 0x28, 0x3c,
					
					//Mode actif :
					0xe, 0x4e, 0xae, 0x44, 0x1f, 0x6f, 0xe, 0xe,
					0x20, 0x52, 0x55, 0x22, 0x70, 0x7c, 0x50, 0xf0,
					0x70, 0x52, 0x55, 0x22, 0xf8, 0xf6, 0x70, 0x70,
					0x4, 0x4a, 0xaa, 0x44, 0xe, 0x3e, 0xa, 0xf
				  },
	Piquier[2*4*8]={
						//Mode statique :
						0x9c, 0xbe, 0x9c, 0xbe, 0xde, 0x9e, 0x9c, 0x94,
						0x72, 0xfa, 0x62, 0x76, 0x7a, 0x72, 0x62, 0x72,
						0x72, 0xfa, 0x52, 0xfa, 0xf6, 0xf2, 0x72, 0x52,
						0x9c, 0xbe, 0x8c, 0xdc, 0xbc, 0x9c, 0x8c, 0x9c,
						
						//Mode actif :
						0x8e, 0x5f, 0x2e, 0x3f, 0x1f, 0xe, 0xf, 0xa,
						0x71, 0xfa, 0x64, 0xfc, 0xf8, 0x70, 0x70, 0x58,
						0x71, 0xfa, 0x54, 0xfc, 0xf8, 0x70, 0xf0, 0x50,
						0x8e, 0x5f, 0x26, 0x3f, 0x1f, 0xe, 0xe, 0x1a,
				  },
	Prisonnier[2*4*32]={
							//Mode statique :
							0x38, 0x38, 0x38, 0x10, 0x7c, 0xaa, 0x38, 0x28,
							0x10, 0x28, 0x28, 0x10, 0x38, 0x28, 0x30, 0x38,
							0x38, 0x28, 0x28, 0x10, 0x7c, 0xaa, 0x38, 0x28,
							0x10, 0x28, 0x28, 0x10, 0x38, 0x28, 0x18, 0x38,
							
							//Mode actif :
							0x3a, 0x3b, 0x3b, 0x13, 0x7e, 0xaa, 0x38, 0x28,
							0x20, 0x54, 0x56, 0x26, 0x76, 0x7c, 0x64, 0x70,
							0x5c, 0xd4, 0xd4, 0xc8, 0x7e, 0x55, 0x1c, 0x14,
							0x4, 0x2a, 0x6a, 0x64, 0x6e, 0x3a, 0x26, 0xe,
						},
	Pretresse[2*4*8]={
						//Mode statique :
						0x38, 0x7c, 0x7c, 0x38, 0x6c, 0x6c, 0x28, 0x38,
						0x18, 0x3c, 0x34, 0x38, 0x3c, 0x34, 0x14, 0x3c,
						0x38, 0x6c, 0x6c, 0x38, 0x6c, 0x6c, 0x28, 0x38,
						0x18, 0x3c, 0x2c, 0x1c, 0x3c, 0x2c, 0x28, 0x3c,

						//Mode actif :
						0x4e, 0xbf, 0x5f, 0xe, 0x7b, 0xb, 0xa, 0xe,
						0x60, 0xf2, 0xd5, 0xe2, 0xf0, 0xdc, 0x50, 0xf0,
						0x72, 0xdd, 0xda, 0x70, 0xde, 0xd0, 0x50, 0x70,
						0x6, 0x4f, 0xab, 0x47, 0xf, 0x3b, 0xa, 0xf
					 },
	Grande_pretresse[1*4*8]={
								0x72, 0xfd, 0xfa, 0x72, 0xfe, 0xd2, 0x52, 0x72,
								0x62, 0xf5, 0xd2, 0xe2, 0xde, 0xd2, 0x52, 0xf2,
								0x72, 0xdd, 0xda, 0x72, 0xde, 0xd2, 0x52, 0x72,
								0x46, 0xaf, 0x4b, 0x47, 0x7f, 0x4b, 0x4a, 0x4f
							},
	Hierophante[1*4*8]={
							0x4e, 0xae, 0x4e, 0xe, 0x5b, 0x6b, 0x4a, 0x4e,
							0x22, 0x55, 0x52, 0x20, 0x52, 0x5e, 0x52, 0xf2,
							0x72, 0x55, 0x52, 0x70, 0xda, 0xd6, 0x52, 0x72,
							0x44, 0xaa, 0x4a, 0x4, 0x4a, 0x7a, 0x4a, 0x4f
							
						},
	Paladin[2*4*8 + 3*8]={
								//Mode statique :
								0x4, 0xe, 0x2e, 0x2e, 0x7f, 0x3f, 0x2e, 0x2a,
								0x20, 0x70, 0x64, 0x74, 0x7e, 0x7c, 0x64, 0x74,
								0x20, 0x70, 0x54, 0x74, 0xfe, 0xfc, 0x74, 0x54,
								0x4, 0xe, 0x26, 0x2e, 0x7e, 0x3e, 0x26, 0x2e,
								
								//Mode actif :
								0x8, 0x5c, 0x5c, 0x5c, 0xfe, 0x5e, 0x1c, 0x14,
								0x20, 0x74, 0x64, 0x74, 0x7e, 0x74, 0x70, 0x58,
								0x20, 0x74, 0x54, 0x74, 0xfe, 0xf4, 0x70, 0x50,
								0x4, 0x2e, 0x26, 0x2e, 0x7e, 0x2e, 0xe, 0x1a,								
								
								//Mode désarme :
								0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
								0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
								0x10, 0x38, 0x28, 0x38, 0x7c, 0x7c, 0x38, 0x28	
						 },
						 
	Ex_hierophante[2*4*8]={
							//Mode statique :
							0x10, 0x28, 0x28, 0x38, 0x6c, 0x6c, 0x28, 0x38,
							0x10, 0x28, 0x2c, 0x1c, 0x2c, 0x28, 0x28, 0x78, 
							0x10, 0x28, 0x28, 0x38, 0x7c, 0x6c, 0x28, 0x38,
							0x10, 0x28, 0x68, 0x70, 0x68, 0x28, 0x28, 0x3c,
							
							//Mode actif :
							0x44, 0xaa, 0x4a, 0xe, 0x7b, 0xb, 0xa, 0xe,
							0x20, 0x52, 0x5d, 0x3a, 0x58, 0x5e, 0x50, 0xf0, 
							0x22, 0x55, 0x52, 0x70, 0xfe, 0xd0, 0x50, 0x70,
							0x4, 0x4a, 0xba, 0x5c, 0x1a, 0x7a, 0xa, 0xf, 							
						  };
						
	unsigned char *tableau[12],*pointeur;
	tableau[EDASTHEREBE]=Edastherebe;
	tableau[FANATIQUE]=Fanatique;
	tableau[PRETRE]=Pretre;
	tableau[PIQUIER]=Piquier;
	tableau[PRISONNIER]=Prisonnier;
	tableau[PRETRESSE]=Pretresse;
	tableau[GRANDE_PRETRESSE]=Grande_pretresse;
	tableau[HIEROPHANTE]=Hierophante;
	tableau[PALADIN]=Paladin;
	tableau[EX_HIEROPHANTE]=Ex_hierophante;
	
	pointeur=tableau[type]+32*mode+8*direction-8;
	if(negatif)negatif_8(pointeur);

	ML_bmp_8_or(CUC pointeur,8*x,8*y);
}

void affichage_etre_16(Type type,char x,char y,char direction,char mode,Bool negatif)
{
	unsigned char Edastherebe[2*4*32]={
										0x7, 0xc0, 0x8, 0x20, 0x10, 0x10, 0x20, 0x8, 0x40, 0x4, 0x80, 0x2, 0xa0, 0xa, 0x50, 0x14, 0x8, 0x20, 0x8, 0x20, 0x4, 0x40, 0x4, 0x40, 0x2, 0x80, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0,
										0x7, 0xc0, 0x8, 0x20, 0x10, 0x10, 0x10, 0x48, 0x10, 0x8, 0x14, 0x8, 0x15, 0x8, 0x12, 0x10, 0x8, 0x20, 0x8, 0x20, 0x4, 0x40, 0x4, 0x40, 0x2, 0x80, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0,
										0x7, 0xc0, 0x8, 0x20, 0x10, 0x10, 0x24, 0x48, 0x40, 0x4, 0x80, 0x2, 0xa7, 0xca, 0x50, 0x14, 0x8, 0x20, 0x8, 0x20, 0x4, 0x40, 0x4, 0x40, 0x2, 0x80, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0,
										0x7, 0xc0, 0x8, 0x20, 0x10, 0x10, 0x24, 0x10, 0x20, 0x10, 0x20, 0x50, 0x21, 0x50, 0x10, 0x90, 0x8, 0x20, 0x8, 0x20, 0x4, 0x40, 0x4, 0x40, 0x2, 0x80, 0x2, 0x80, 0x1, 0x0, 0x0, 0x0,
									 
										0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x2, 0x40, 0x2, 0x40, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x2, 0x40, 0x2, 0x40, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x2, 0x40, 0x2, 0x40, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
										0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x80, 0x2, 0x40, 0x2, 0x40, 0x1, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
									 },
	Fanatique[2*4*32]={
						//Mode statique :
						0x1f, 0x20, 0x1f, 0x20, 0x1f, 0x30, 0x1f, 0x78, 0x3f, 0xf8, 0x7f, 0xf8, 0x7f, 0xf0, 0x7f, 0x50, 0x7f, 0x50, 0x7f, 0x50, 0x6e, 0x50, 0x1f, 0x50, 0x1b, 0x50, 0x1b, 0x50, 0x1b, 0x50, 0x3b, 0xa0,
						0x7, 0xa0, 0x7, 0x20, 0x6, 0x60, 0x7, 0xf8, 0x5, 0xd0, 0x7, 0xd0, 0x7, 0x50, 0x6, 0xd0, 0x7, 0x50, 0x7, 0xd0, 0x7, 0xd0, 0x7, 0x50, 0x7, 0x50, 0x7, 0x50, 0x7, 0x50, 0x7, 0xa0,
						0xf, 0x90, 0xd, 0x90, 0x8, 0x98, 0xd, 0xbc, 0x1d, 0xec, 0x3f, 0xec, 0x3d, 0xe8, 0x3a, 0xa8, 0x3d, 0xa8, 0x3f, 0xa8, 0x37, 0x28, 0xf, 0xa8, 0xd, 0xa8, 0xd, 0xa8, 0xd, 0xa8, 0x1d, 0xd0,
						0x5, 0xe0, 0x4, 0xe0, 0x6, 0x60, 0x1f, 0xe0, 0xb, 0xa0, 0xb, 0xe0, 0xa, 0xe0, 0xb, 0x60, 0xa, 0xe0, 0xb, 0xe0, 0xb, 0xe0, 0xa, 0xe0, 0xa, 0xe0, 0xa, 0xe0, 0xa, 0xe0, 0x5, 0xe0,
						
						//Mode actif :
						0xc7, 0xc0, 0xa7, 0xc0, 0x57, 0xc0, 0x2f, 0xc0, 0x1f, 0xe0, 0x1f, 0xf0, 0x1f, 0xf8, 0x1f, 0xf8, 0xf, 0xf8, 0x7, 0xf0, 0x3, 0xa0, 0x7, 0xd0, 0x6, 0xc8, 0x6, 0xc0, 0x6, 0xc0, 0xe, 0xe0,
						0x7c, 0x3, 0x74, 0x5, 0x60, 0xa, 0x74, 0x14, 0x74, 0x28, 0x7c, 0x50, 0x38, 0xa0, 0x5b, 0x40, 0x5d, 0x80, 0x6e, 0x80, 0x76, 0x0, 0x78, 0x0, 0x7c, 0x0, 0x7c, 0x0, 0xee, 0x0, 0xc7, 0x0,
						0x7, 0xc6, 0x6, 0xca, 0x4, 0x54, 0x6, 0xe8, 0xe, 0xd0, 0x1f, 0xb0, 0x3f, 0x70, 0x36, 0xf0, 0x39, 0xe0, 0x1d, 0xc0, 0xe, 0x80, 0x17, 0xc0, 0x26, 0xc0, 0x6, 0xc0, 0x6, 0xc0, 0xe, 0xe0,
						0xc0, 0x3e, 0xa0, 0x2e, 0x50, 0x6, 0x28, 0x2e, 0x14, 0x2e, 0xa, 0x3e, 0x5, 0x1c, 0x2, 0xda, 0x1, 0xba, 0x1, 0x76, 0x0, 0x6e, 0x0, 0x1e, 0x0, 0x3e, 0x0, 0x3e, 0x0, 0x77, 0x0, 0xe3
					  },
	Pretre[2*4*32]={
						//Mode statique :
						0x3, 0x80, 0x7, 0xc0, 0x7, 0xc0, 0x7, 0xc0, 0x7, 0xc0, 0x3, 0x98, 0xf, 0xe4, 0x1f, 0xf2, 0x1f, 0xfa, 0x1f, 0xdc, 0x17, 0xdc, 0x17, 0xe0, 0xf, 0xe0, 0x7, 0xc0, 0xf, 0xe0, 0x1f, 0xf0,
						0x3, 0x80, 0x7, 0xc0, 0x7, 0x40, 0x6, 0xc0, 0x6, 0x40, 0x3, 0x80, 0x7, 0xf0, 0x7, 0xc8, 0x7, 0xc4, 0x5, 0xec, 0x6, 0x78, 0x7, 0x30, 0x5, 0xe0, 0x6, 0xc0, 0xf, 0xc0, 0x1f, 0xe0,
						0x1, 0xc0, 0x3, 0xe0, 0x2, 0x20, 0x3, 0x60, 0x2, 0x20, 0x19, 0xc0, 0x27, 0xf0, 0x42, 0xf8, 0x71, 0x78, 0x28, 0xf8, 0x29, 0xe8, 0x1f, 0x68, 0x6, 0xf0, 0x3, 0xe0, 0x7, 0xf0, 0xf, 0xf8,
						0x1, 0xc0, 0x3, 0xe0, 0x2, 0xe0, 0x3, 0x60, 0x2, 0x60, 0x1, 0xc0, 0xf, 0xe0, 0x13, 0xe0, 0x23, 0xe0, 0x2b, 0xe0, 0x17, 0x60, 0x17, 0x60, 0xf, 0xe0, 0x3, 0xe0, 0x3, 0xf0, 0x7, 0xf8,
	
						//Mode actif :
						0x1, 0xc0, 0x3, 0xe0, 0x3, 0xe0, 0x63, 0xe0, 0x93, 0xe0, 0x91, 0xcc, 0x67, 0xf2, 0xf, 0xf9, 0xff, 0xfd, 0x9b, 0xee, 0x73, 0xee, 0x3, 0xf0, 0x3, 0xf0, 0x3, 0xe0, 0x7, 0xf0, 0xf, 0xf8,
						0x3, 0x80, 0x7, 0xc0, 0x7, 0x40, 0x6, 0xcc, 0x6, 0x52, 0x3, 0x92, 0x7, 0xcc, 0x7, 0xc0, 0xf, 0xfe, 0xb, 0x92, 0xb, 0x9c, 0xb, 0x90, 0xe, 0xf0, 0x7, 0xc0, 0xf, 0xc0, 0x1f, 0xe0,
						0x3, 0x80, 0x7, 0xc0, 0x4, 0x40, 0x6, 0xc6, 0x4, 0x49, 0x33, 0x89, 0x4f, 0xe6, 0x85, 0xf0, 0xe2, 0xff, 0x51, 0xd9, 0x53, 0xce, 0x3e, 0xc0, 0xd, 0xc0, 0x7, 0xc0, 0xf, 0xe0, 0x1f, 0xf0,
						0x1, 0xc0, 0x3, 0xe0, 0x2, 0xe0, 0x33, 0x60, 0x4a, 0x60, 0x49, 0xc0, 0x33, 0xe0, 0x3, 0xe0, 0x7f, 0xe0, 0x4f, 0xe0, 0x3f, 0xe0, 0x3, 0xe0, 0x3, 0xe0, 0x3, 0xe0, 0x3, 0xf0, 0x7, 0xf8
					},
	Piquier[2*4*32]={
						//Mode statique :
						0x10, 0xe0, 0x11, 0xf0, 0x13, 0xf8, 0x29, 0xf0, 0x11, 0xf0, 0x10, 0xe0, 0x13, 0xf8, 0x17, 0xfc, 0x1d, 0xfc, 0x19, 0xfc, 0x10, 0xec, 0x11, 0xf0, 0x11, 0xb0, 0x11, 0xb0, 0x11, 0xb0, 0x13, 0xb8,
						0x6, 0x20, 0xf, 0x20, 0x1f, 0xa0, 0xb, 0x50, 0x9, 0x20, 0x6, 0x20, 0xf, 0x20, 0xf, 0xe0, 0xf, 0xe0, 0xf, 0x20, 0xf, 0x20, 0xe, 0x20, 0xe, 0x20, 0xe, 0x20, 0xe, 0x20, 0xf, 0x20,
						0x7, 0x8, 0xf, 0x88, 0x1f, 0xc8, 0xd, 0x94, 0x8, 0x88, 0x7, 0x8, 0x1f, 0xc8, 0x3f, 0xe8, 0x3f, 0xb8, 0x38, 0x98, 0x37, 0x8, 0xf, 0x88, 0xd, 0x88, 0xd, 0x88, 0xd, 0x88, 0x1d, 0xc8,
						0x8, 0xc0, 0x9, 0xe0, 0xb, 0xf0, 0x15, 0xa0, 0x9, 0x20, 0x8, 0xc0, 0x9, 0xe0, 0xf, 0xe0, 0xf, 0xe0, 0x9, 0xe0, 0x9, 0xe0, 0x8, 0xe0, 0x8, 0xe0, 0x8, 0xe0, 0x8, 0xe0, 0x9, 0xe0,
						
						//Mode actif :
						0x81, 0xc0, 0x53, 0xe0, 0x27, 0xf0, 0x53, 0xe0, 0x3b, 0xe0, 0x35, 0xc0, 0x3f, 0xf0, 0xf, 0xf8, 0x3, 0xec, 0x2, 0x2c, 0x1, 0xec, 0x3, 0xfc, 0x3, 0x68, 0x3, 0x64, 0x3, 0x62, 0x7, 0x70,
						0x3, 0x1, 0x7, 0x8a, 0xf, 0xc4, 0x5, 0x8a, 0x4, 0x98, 0x3, 0x38, 0xf, 0xd8, 0x1f, 0xf8, 0x3f, 0xf0, 0x37, 0x80, 0x34, 0x80, 0x3f, 0x80, 0x37, 0xc0, 0x27, 0xc0, 0x4e, 0xe0, 0xc, 0x70,
						0x7, 0x2, 0xf, 0x94, 0x1f, 0xc8, 0xd, 0x94, 0x8, 0xb8, 0x7, 0x58, 0x1f, 0xf8, 0x3f, 0xe0, 0x6f, 0x80, 0x6c, 0x80, 0x6f, 0x0, 0x7f, 0x80, 0x2d, 0x80, 0x4d, 0x80, 0x8d, 0x80, 0x1d, 0xc0,
						0x80, 0xc0, 0x51, 0xe0, 0x23, 0xf0, 0x51, 0xa0, 0x19, 0x20, 0x1c, 0xc0, 0x1b, 0xf0, 0x1f, 0xf8, 0xf, 0xfc, 0x1, 0xec, 0x1, 0x2c, 0x1, 0xfc, 0x3, 0xec, 0x3, 0xe4, 0x7, 0x72, 0xe, 0x30
					},
	Prisonnier[2*4*32]={
							//Mode statique :
							0x3, 0x80, 0x7, 0xc0, 0x7, 0xc0, 0x7, 0xc0, 0x7, 0xc0, 0x3, 0x80, 0xc, 0x60, 0x10, 0x10, 0x14, 0x50, 0x17, 0xd0, 0x1c, 0x70, 0x17, 0xd0, 0xf, 0xe0, 0x6, 0xc0, 0x6, 0xc0, 0xe, 0xe0,
							0x3, 0x80, 0x7, 0xc0, 0x7, 0x40, 0x6, 0xc0, 0x6, 0x40, 0x3, 0x80, 0x4, 0x40, 0x5, 0x40, 0x5, 0x40, 0x5, 0x40, 0x5, 0xc0, 0x7, 0x40, 0x3, 0x80, 0x3, 0x80, 0x3, 0x80, 0x3, 0xc0,
							0x3, 0x80, 0x7, 0xc0, 0x4, 0x40, 0x6, 0xc0, 0x4, 0x40, 0x3, 0x80, 0xc, 0x60, 0x10, 0x10, 0x14, 0x50, 0x17, 0xd0, 0x1c, 0x70, 0x17, 0xd0, 0xf, 0xe0, 0x6, 0xc0, 0x6, 0xc0, 0xe, 0xe0,
							0x1, 0xc0, 0x3, 0xe0, 0x2, 0xe0, 0x3, 0x60, 0x2, 0x60, 0x1, 0xc0, 0x2, 0x20, 0x2, 0xa0, 0x2, 0xa0, 0x2, 0xa0, 0x3, 0xa0, 0x2, 0xe0, 0x1, 0xc0, 0x1, 0xc0, 0x1, 0xc0, 0x3, 0xc0,
							
							//Mode actif :
							0x7, 0x0, 0xf, 0x80, 0xf, 0x88, 0xf, 0x8c, 0xf, 0x8a, 0x7, 0xa, 0x38, 0xca, 0x40, 0x2a, 0x98, 0xdc, 0xef, 0xa2, 0xa8, 0x9c, 0x4f, 0x8c, 0xf, 0x80, 0xd, 0x80, 0xd, 0x80, 0x1d, 0xc0,
							0x7, 0x0, 0xf, 0x80, 0xe, 0xa0, 0xd, 0xb0, 0xc, 0xa8, 0x7, 0x28, 0xa, 0xa8, 0xa, 0xa8, 0xa, 0xa8, 0x9, 0x70, 0x8, 0xa8, 0xf, 0xf0, 0x7, 0x30, 0x7, 0x0, 0x7, 0x0, 0x7, 0x80,
							0x1, 0xc0, 0x3, 0xe0, 0x22, 0x20, 0x63, 0x60, 0xa2, 0x20, 0xa1, 0xc0, 0xa6, 0x38, 0xa8, 0x4, 0x76, 0x32, 0xab, 0xee, 0x72, 0x2a, 0x63, 0xe4, 0x3, 0xe0, 0x3, 0x60, 0x3, 0x60, 0x7, 0x70,
							0x0, 0xe0, 0x1, 0xf0, 0x5, 0x70, 0xd, 0xb0, 0x15, 0x30, 0x14, 0xe0, 0x15, 0x10, 0x15, 0x50, 0x15, 0x50, 0xf, 0x50, 0x15, 0xd0, 0xf, 0x70, 0xc, 0xe0, 0x0, 0xe0, 0x0, 0xe0, 0x1, 0xe0
					   },
	Pretresse[2*4*32]={
						//Mode statique :
						0x0, 0x0, 0x3, 0x80, 0x7, 0xc0, 0xf, 0xe0, 0xf, 0xe0, 0xf, 0xe0, 0xf, 0xe0, 0xf, 0xe0, 0x17, 0xd0, 0x17, 0xd0, 0x1f, 0xf0, 0x17, 0xd0, 0xd, 0x60, 0x4, 0x40, 0x8, 0x20, 0x1f, 0xf0,
						0x0, 0x0, 0x1, 0xc0, 0x3, 0xe0, 0x7, 0xa0, 0x7, 0x60, 0x7, 0x20, 0x7, 0xc0, 0x7, 0x20, 0x7, 0xa0, 0x6, 0xa0, 0x6, 0xe0, 0x7, 0xa0, 0x6, 0x60, 0x2, 0x20, 0x4, 0x20, 0xf, 0xf0,
						0x0, 0x0, 0x3, 0x80, 0x7, 0xc0, 0xc, 0x60, 0xe, 0xe0, 0xc, 0x60, 0xf, 0xe0, 0xc, 0x60, 0x10, 0x10, 0x14, 0x50, 0x1c, 0x70, 0x17, 0xd0, 0xc, 0x60, 0x4, 0x40, 0x8, 0x20, 0x1f, 0xf0,
						0x0, 0x0, 0x3, 0x80, 0x7, 0xc0, 0x5, 0xe0, 0x6, 0xe0, 0x4, 0xe0, 0x3, 0xe0, 0x4, 0xe0, 0x5, 0xe0, 0x5, 0x60, 0x7, 0x60, 0x5, 0xe0, 0x6, 0x60, 0x4, 0x40, 0x4, 0x20, 0xf, 0xf0,
	
						//Mode actif :
						0x0, 0x0, 0x0, 0xe0, 0x1, 0xf0, 0x3, 0xf8, 0x33, 0xf8, 0x4b, 0xf8, 0x4b, 0xf8, 0x33, 0xf8, 0x5, 0xf4, 0x7b, 0xf4, 0x4d, 0xfc, 0x39, 0xf4, 0x1, 0x58, 0x1, 0x10, 0x2, 0x8, 0x7, 0xfc,
						0x0, 0x0, 0x7, 0x0, 0xf, 0x80, 0x1e, 0x80, 0x1d, 0x98, 0x1c, 0xa4, 0x1f, 0x24, 0x1c, 0x98, 0x1e, 0x80, 0x1a, 0xfc, 0x1b, 0xa4, 0x1e, 0xf8, 0x19, 0x80, 0x8, 0x80, 0x10, 0x80, 0x3f, 0xc0,
						0x0, 0x0, 0x7, 0x0, 0xf, 0x80, 0x18, 0xc0, 0x1d, 0xcc, 0x18, 0xd2, 0x1f, 0xd2, 0x18, 0xcc, 0x20, 0x20, 0x28, 0xde, 0x38, 0xb2, 0x2f, 0x9c, 0x18, 0x80, 0x8, 0x80, 0x10, 0x40, 0x3f, 0xe0,
						0x0, 0x0, 0x0, 0xe0, 0x1, 0xf0, 0x1, 0x78, 0x19, 0xb8, 0x25, 0x38, 0x24, 0xf8, 0x19, 0x38, 0x1, 0xb8, 0x3f, 0x18, 0x24, 0x98, 0x1f, 0x38, 0x1, 0x18, 0x1, 0x10, 0x1, 0x8, 0x3, 0xfc
					  },
	Grande_pretresse[1*4*32]={
							    0x0, 0x18, 0xe, 0x24, 0x1f, 0x24, 0x3f, 0x98, 0x3f, 0xbc, 0x3f, 0x98, 0x3f, 0x98, 0x3f, 0xf8, 0x5f, 0x4, 0x5f, 0xf8, 0x7f, 0x18, 0x55, 0x18, 0x31, 0x18, 0x11, 0x18, 0x20, 0x98, 0x7f, 0xd8,
								0x0, 0x30, 0xe, 0x48, 0x1f, 0x48, 0x3d, 0x30, 0x3b, 0x78, 0x39, 0x30, 0x3e, 0x30, 0x39, 0xf8, 0x3d, 0x24, 0x35, 0xf8, 0x37, 0x30, 0x35, 0x30, 0x13, 0x30, 0x11, 0x30, 0x21, 0x30, 0x7f, 0xb0,
								0x0, 0x18, 0xe, 0x24, 0x1f, 0x24, 0x31, 0x98, 0x3b, 0xbc, 0x31, 0x98, 0x3f, 0x98, 0x31, 0xfc, 0x40, 0x12, 0x51, 0xfc, 0x71, 0x18, 0x51, 0x18, 0x31, 0x18, 0x11, 0x18, 0x20, 0x98, 0x7f, 0xd8,
								0x18, 0x0, 0x24, 0xe0, 0x25, 0xf0, 0x19, 0x78, 0x3d, 0xb8, 0x19, 0x38, 0x18, 0xf8, 0x1f, 0x38, 0x20, 0x38, 0x1f, 0xd8, 0x19, 0x18, 0x19, 0x18, 0x19, 0x10, 0x19, 0x10, 0x19, 0x8, 0x1b, 0xfc
							  },
	Hierophante[1*4*32]={
							0x18, 0xa8, 0x24, 0x70, 0x24, 0xf8, 0x18, 0xf8, 0x0, 0xf8, 0x24, 0x70, 0x19, 0x8c, 0x1a, 0x2, 0x1d, 0x8a, 0x22, 0x8a, 0x1c, 0x8e, 0x18, 0x8a, 0x18, 0x8c, 0x18, 0x88, 0x19, 0x4, 0x1b, 0xfe,
							0x5, 0x30, 0xe, 0x48, 0x1f, 0x48, 0x1d, 0x30, 0x1b, 0x0, 0x11, 0x48, 0xe, 0x30, 0x11, 0x30, 0x15, 0xf8, 0x15, 0x24, 0x17, 0xf8, 0x15, 0x30, 0x13, 0x30, 0x11, 0x30, 0x21, 0x30, 0x7f, 0xb0,
							0x15, 0x18, 0xe, 0x24, 0x15, 0x24, 0x1b, 0x18, 0x11, 0x0, 0xe, 0x24, 0x35, 0x98, 0x40, 0x58, 0x51, 0xbc, 0x55, 0x52, 0x7b, 0x3c, 0x55, 0x18, 0x31, 0x18, 0x11, 0x18, 0x20, 0x98, 0x7f, 0xd8,
							0xc, 0xa0, 0x12, 0x70, 0x12, 0xf8, 0xc, 0xb8, 0x0, 0xd8, 0x12, 0x88, 0xc, 0x70, 0xc, 0x88, 0x1f, 0x28, 0x24, 0x48, 0x1f, 0x88, 0xc, 0x88, 0xc, 0x88, 0xc, 0x88, 0xc, 0x84, 0xd, 0xfe
						},
	Paladin[2*4*32 + 3*32]={
								//Mode statique :
								0x2, 0xe8, 0x3, 0xf8, 0x1, 0xf0, 0x1, 0xf0, 0x11, 0xf0, 0x13, 0xf8, 0x1f, 0xfc, 0x1f, 0xfc, 0x39, 0xfc, 0x29, 0xfc, 0x28, 0xec, 0x29, 0xf0, 0x29, 0xb0, 0x29, 0xb0, 0x29, 0xb0, 0x13, 0xb8,
								0x3, 0x0, 0x7, 0x80, 0x7, 0x80, 0x7, 0x0, 0x7, 0x8, 0x7, 0x88, 0x7, 0xf8, 0x7, 0x78, 0x7, 0x1c, 0x7, 0x94, 0x7, 0x94, 0x7, 0x14, 0x7, 0x14, 0x7, 0x14, 0x7, 0x14, 0x7, 0x88,
								0x17, 0x40, 0x1f, 0xc0, 0xd, 0x80, 0x8, 0x80, 0x8, 0x88, 0x1d, 0xc8, 0x37, 0x78, 0x38, 0xf8, 0x3d, 0x9c, 0x3f, 0x94, 0x37, 0x14, 0xf, 0x94, 0xd, 0x94, 0xd, 0x94, 0xd, 0x94, 0x1d, 0xc8,
								0x0, 0xc0, 0x1, 0xe0, 0x1, 0xe0, 0x0, 0xe0, 0x10, 0xe0, 0x11, 0xe0, 0x1f, 0xe0, 0x1f, 0xe0, 0x38, 0xe0, 0x29, 0xe0, 0x29, 0xe0, 0x28, 0xe0, 0x28, 0xe0, 0x28, 0xe0, 0x28, 0xe0, 0x11, 0xe0,
								
								//Mode actif :
								0x0, 0xba, 0x0, 0xfe, 0x0, 0x7c, 0xc0, 0x7c, 0xa0, 0x7c, 0x50, 0xfe, 0x29, 0xff, 0x17, 0xff, 0xf, 0x7f, 0x6, 0x7f, 0x1, 0x3b, 0x0, 0x7c, 0x0, 0x6c, 0x0, 0x6c, 0x0, 0x6c, 0x0, 0xee,
								0x0, 0x18, 0x0, 0x3c, 0x0, 0x3c, 0x30, 0x1c, 0x28, 0x1c, 0x14, 0x3c, 0xa, 0x7c, 0x5, 0xfc, 0x3, 0xfc, 0x1, 0xbc, 0x0, 0x7c, 0x0, 0x1c, 0x0, 0x1c, 0x0, 0x1c, 0x0, 0x1c, 0x0, 0x3c,
								0x5d, 0x0, 0x7f, 0x0, 0x36, 0x0, 0x22, 0x3, 0x22, 0x5, 0x77, 0xa, 0xdd, 0x94, 0xe3, 0xe8, 0xf6, 0xf0, 0xfe, 0x60, 0xdc, 0x80, 0x3e, 0x0, 0x36, 0x0, 0x36, 0x0, 0x36, 0x0, 0x77, 0x0,
								0x18, 0x0, 0x3c, 0x0, 0x3c, 0x0, 0x38, 0xc, 0x38, 0x14, 0x3c, 0x28, 0x3e, 0x50, 0x3b, 0xa0, 0x3b, 0xc0, 0x3d, 0x80, 0x3e, 0x0, 0x38, 0x0, 0x38, 0x0, 0x38, 0x0, 0x38, 0x0, 0x3c, 0x0,
								
								//Mode désarme :
								0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
								0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0,
								0xb, 0xa0, 0xf, 0xe0, 0x6, 0xc0, 0x4, 0x40, 0x4, 0x40, 0xe, 0xe0, 0x1b, 0xb0, 0x1c, 0x70, 0x1e, 0xf0, 0x1f, 0xf0, 0x1b, 0xb0, 0x7, 0xc0, 0x6, 0xc0, 0x6, 0xc0, 0x6, 0xc0,0xe, 0xe0
						   },
	Ex_hierophante[2*4*32]={
							//Mode statique :
							0x0, 0x0, 0x3, 0x80, 0x4, 0x40, 0x4, 0x40, 0x4, 0x40, 0x7, 0xc0, 0xc, 0x60, 0x10, 0x10, 0x14, 0x50, 0x14, 0x50, 0x1c, 0x70, 0x14, 0x50, 0xc, 0x60, 0x4, 0x40, 0x8, 0x20, 0x1f, 0xf0,
							0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x4, 0x40, 0x4, 0xc0, 0x4, 0x60, 0x3, 0xe0, 0x4, 0xe0, 0x5, 0x60, 0x5, 0x60, 0x5, 0xc0, 0x5, 0x40, 0x4, 0xc0, 0x4, 0x40, 0x8, 0x40, 0x1f, 0xe0,
							0x0, 0x0, 0x3, 0x80, 0x4, 0x40, 0x6, 0xc0, 0x4, 0x40, 0x7, 0xc0, 0xf, 0xe0, 0x13, 0x90, 0x17, 0xd0, 0x15, 0x50, 0x1c, 0x70, 0x14, 0x50, 0xc, 0x60, 0x4, 0x40, 0x8, 0x20, 0x1f, 0xf0,
							0x0, 0x0, 0x0, 0x0, 0x3, 0x80, 0x4, 0x40, 0x6, 0x40, 0xc, 0x40, 0xf, 0x80, 0xe, 0x40, 0xd, 0x40, 0xd, 0x40, 0x7, 0x40, 0x5, 0x40, 0x6, 0x40, 0x4, 0x40, 0x4, 0x20, 0xf, 0xf0,
	
							//Mode actif :
							0x0, 0x0, 0x0, 0xe0, 0x1, 0x10, 0x31, 0x10, 0x49, 0x10, 0x49, 0xf0, 0x33, 0x18, 0x4, 0x4, 0x7b, 0x14, 0x4d, 0x14, 0x39, 0x1c, 0x1, 0x14, 0x1, 0x18, 0x1, 0x10, 0x2, 0x8, 0x7, 0xfc,
							0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x8, 0x80, 0x9, 0x98, 0x8, 0xe4, 0x7, 0xe4, 0x9, 0xd8, 0xa, 0xc0, 0xa, 0xfc, 0xb, 0xa4, 0xa, 0xf8, 0x9, 0x80, 0x8, 0x80, 0x10, 0x80, 0x3f, 0xc0,
							0x0, 0x0, 0x7, 0x0, 0x8, 0x80, 0xd, 0x8c, 0x8, 0x92, 0xf, 0x92, 0x1f, 0xcc, 0x27, 0x20, 0x2f, 0xde, 0x2a, 0xb2, 0x38, 0x9c, 0x28, 0x80, 0x18, 0x80, 0x8, 0x80, 0x10, 0x40, 0x3f, 0xe0,
							0x0, 0x0, 0x0, 0x0, 0x0, 0xe0, 0x1, 0x10, 0x19, 0x90, 0x27, 0x10, 0x27, 0xe0, 0x1b, 0x10, 0x3, 0x90, 0x3f, 0x10, 0x24, 0x90, 0x1f, 0x10, 0x1, 0x10, 0x1, 0x10, 0x1, 0x8, 0x3, 0xfc
						};
						
	unsigned char *tableau[12],*pointeur;
	tableau[EDASTHEREBE]=Edastherebe;
	tableau[FANATIQUE]=Fanatique;
	tableau[PRETRE]=Pretre;
	tableau[PIQUIER]=Piquier;
	tableau[PRISONNIER]=Prisonnier;
	tableau[PRETRESSE]=Pretresse;
	tableau[GRANDE_PRETRESSE]=Grande_pretresse;
	tableau[HIEROPHANTE]=Hierophante;
	tableau[PALADIN]=Paladin;
	tableau[EX_HIEROPHANTE]=Ex_hierophante;
	
	pointeur=tableau[type]+128*mode+32*direction-32;
	if(negatif)negatif_16((unsigned short *)pointeur);
	
	ML_bmp_16_or((const unsigned short *)pointeur,16*x,16*y);
}

void negatif_8(unsigned char *bitmap)
{
	char i;
	for(i=0;i<8;i++)
	{
		bitmap[i]=255-bitmap[i];
		if(i==0 || i==7)bitmap[i]&=126;		//Adoucit le carré en tronquant les coins
	}
}

void negatif_16(unsigned short *bitmap)
{
	char i;
	for(i=0;i<16;i++)
	{
		bitmap[i]=65535-bitmap[i];
		
		//Adoucit le carré en tronquant les coins :
		if(i==0 || i==15)bitmap[i]&=16380;
		if(i==1 || i==14)bitmap[i]&=32766;
	}
}

void repere_8(char x,char y)
{
	ML_pixel(8*x+2,8*y+2,ML_XOR);
	ML_pixel(8*x+4,8*y+2,ML_XOR);
	ML_pixel(8*x+2,8*y+4,ML_XOR);
	ML_pixel(8*x+4,8*y+4,ML_XOR);
	ML_pixel(8*x+3,8*y+3,ML_XOR);
}