#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"

#define NEGATIF(duree)	inversion_ecran();\
						ML_display_vram();\
						Sleep(duree);
#define NOMBRE_POINTS 300
#define NOMBRE_ENTITES 80

void gestion_cinematiques(Donnees *donnees,Map *map,General *general)
{
	short salle=general->salle;
	switch(donnees->mission)
	{
		case TUER_PRETRE: 
			if(salle==1)
			{
				introduction();
				pretre_surpris_salle1(donnees,map,general);
				donnees->mission++;
			}
		Bcase(ALLER_SOURCE_ETHER)
			if(salle==2)
			{
				infiltration_salle2(map,general);
				donnees->mission++;
			}
		Bcase(TROUVER_PRETRESSE)
			if(general->salle==14)
			{
				encerclement_salle14(donnees,map,general);
				donnees->mission++;
			}
			
			if(general->salle==5)
			{
				encerclement_salle5(donnees,map,general);
				donnees->mission++;			
			}
		Bcase(ACCEDER_SOUTERRAIN)
			if(general->salle==11)
			{
				souterrain_salle11(map,general);
				donnees->mission++;
				donnees->cinematique_secondaire=FAUX;
			}
		Bcase(TROUVER_PALADIN)
			if(general->salle==7)
			{
				short salles[]={19};
				rencontre_paladin_salle7(map,general);
				donnees->mission++;
				reinitialisation_salle(salles,1,donnees);
			}
			
			if(general->salle==20 && general->x==12 && !donnees->cinematique_secondaire)
			{
				discretion_salle20(map,general);
				donnees->cinematique_secondaire=VRAI;
			}
		Bcase(ATTAQUER_SALLE19)
			if(general->salle==19)
			{
				assaut_salle19(map,general);
				general->acces_sortie=FAUX;
				donnees->condition=VRAI;
			}
		Bcase(ATTAQUER_SALLE25)
			if(general->salle==25)
			{
				assaut_salle25(map,general);
				general->acces_sortie=FAUX;
				donnees->condition=VRAI;
			}
		Bcase(ALLER_SALLE23)
			if(general->salle==23 && general->x==1)
			{
				activation_statue_salle23(map,general);
				donnees->mission++;
			}
		Bcase(TROUVER_EX_HIEROPHANTE)
			if(general->salle==29)
			{
				rencontre_ex_hierophante(map,general,donnees);
				donnees->mission++;
			}
		Bcase(DIVERSION_SALLE4)
			if(general->salle==4)
			{
				short salles[]={5};
				reinitialisation_salle(salles,1,donnees);
				diversion_salle4(map,general,donnees);
				general->acces_sortie=FAUX;
			}
		Bcase(ALLER_SALLE14)
			if(general->salle==14)
			{
				rencontre_paladin_salle14(map,general);			
				donnees->mission++;
			}
		Bcase(ALLER_SALLE5)
			if(general->salle==5)
			{
				preparatifs_salle5(map,general);
				donnees->mission++;
			}
		Bcase(ATTAQUER_HIEROPHANTE)
			if(general->salle==6)
			{
				assaut_final(map,general);
				general->acces_sortie=FAUX;
			}
		break;
	}

}

void surpris(char x,char y,Bool zoom)
{
	x<<=3+zoom;
	y<<=3+zoom;
	
	ML_pixel(x+8,y+12,ML_BLACK);
	ML_vertical_line(x+8,y+10,y+6,ML_BLACK);
}

void fenetre(char taille,Bool depassement,unsigned int key,char texte[200])
{
	//key=0 : touche EXE
	//key=1 : aucune touche

	char y=68-8*taille,j=0,i;
	if(!key)key=KEY_CTRL_EXE;
	
	ML_rectangle(0,63,127-16*!depassement,64-8*taille,0,0,ML_WHITE);
	
	ML_horizontal_line(65-8*taille,1,126-16*!depassement,ML_BLACK);
	ML_horizontal_line(66-8*taille,0,127-16*!depassement,ML_BLACK);
	ML_horizontal_line(62,0,127-16*!depassement,ML_BLACK);
	ML_horizontal_line(63,1,126-16*!depassement,ML_BLACK);
	
	ML_vertical_line(0,66-8*taille,62,ML_BLACK);
	ML_vertical_line(1,65-8*taille,63,ML_BLACK);
	ML_vertical_line(126-16*!depassement,65-8*taille,63,ML_BLACK);
	ML_vertical_line(127-16*!depassement,66-8*taille,62,ML_BLACK);
	
	for(i=0;texte[i];i++)
	{
		if(texte[i+1]=='/' || !texte[i+1])
		{
			texte[i+1]=0;
			PrintMini(3,y,CUC texte+j,1);
			i++;
			j=i+1;
			y+=6;
		}
	}
	
	ML_display_vram();
	if(key!=1)
	{
		while(IsKeyDown(key))Sleep(100);
		while(IsKeyUp(key))Sleep(100);
	}
}



void introduction()
{
	char texte1[]="L'au-dela...\0",
		 texte2[]="Un ocean d'ether...\0",
		 texte3[]="Peuple de mysteres...\0",
		 texte4[]="Et d'ames paisibles...\0",
		 texte5[]="Sauf une.\0",
		 texte6[]="Edastherebe, ame solitaire,/s'ennuyait dans la monotonie/du silence\0",
		 texte7[]="Il desirait de l'aventure, et/par chance, c'est l'aventure/qui vint a lui !\0",
		 texte8[]="Ses deambulations le menerent/un jour jusqu'a un vortex/metaphysique\0",
		 texte9[]="Une des rares portes qui/menent au monde materiel\0",
		 texte10[]="Edastherebe n'hesita qu'un/court instant !\0",
		 *pointeur;
	short points[NOMBRE_POINTS],entites[20];
	short i,j,x,y;
	char X=63,Y=20,x_cible;
	int temps;	//Et en minuscules ! Non mais !
	Bool condition;
	
	ML_clear_vram();
	for(i=0;i<NOMBRE_POINTS;i+=2)
	{
		points[i]=alea(0,255);
		points[i+1]=alea(0,63);
	}
	
	for(i=0;i<NOMBRE_ENTITES;i+=2)
	{
		do
		{
			x=alea(1,510);
			y=alea(1,62);
			
			condition=FAUX;
			for(j=0;j<i;j+=2)if(DISTANCE(x,y,entites[j],entites[j+1])<7)condition=VRAI;
		}while(condition);

		entites[i]=x;
		entites[i+1]=y;
		
		ML_pixel(entites[i]+1,entites[i+1],ML_BLACK);
		ML_pixel(entites[i]-1,entites[i+1],ML_BLACK);
		ML_pixel(entites[i],entites[i+1]+1,ML_BLACK);
		ML_pixel(entites[i],entites[i+1]-1,ML_BLACK);
	}

	
	for(i=0;i<127;i++)
	{
		ML_clear_vram();
		for(j=0;j<NOMBRE_POINTS;j+=2)ML_pixel(points[j]-i,points[j+1],ML_BLACK);
		for(j=0;j<NOMBRE_ENTITES;j++)
		{
			ML_pixel(entites[j]+1-2*i,entites[j+1],ML_BLACK);
			ML_pixel(entites[j]-1-2*i,entites[j+1],ML_BLACK);
			ML_pixel(entites[j]-2*i,entites[j+1]+1,ML_BLACK);
			ML_pixel(entites[j]-2*i,entites[j+1]-1,ML_BLACK);
		}
		
		pointeur=NULL;
		if(i>24)pointeur=texte1;
		if(i>49)pointeur=texte2;
		if(i>74)pointeur=texte3;
		if(i>99)pointeur=texte4;
		if(i==126)pointeur=texte5;
		if(pointeur)fenetre(2,VRAI,1,pointeur);
		
		ML_display_vram();
		if(IsKeyDown(KEY_CTRL_SHIFT))
		{
			while(IsKeyDown(KEY_CTRL_SHIFT))Sleep(100);
			return;
		}
		Sleep(100);
	}
	
	Sleep(1000);
	for(i=0;i<NOMBRE_POINTS/4;i+=2)
	{
		points[i]=alea(0,127);
		points[i+1]=alea(0,63);
	}
	
	temps=RTC_getTicks();
	while(RTC_getTicks()-temps<10*128)		//Duree : 10 secondes
	{
		ML_clear_vram();
		for(i=0;i<NOMBRE_POINTS/4;i+=2)ML_pixel(points[i],points[i+1],ML_BLACK);
		
		ML_vertical_line(X-3,Y-1,Y+1,ML_BLACK);
		ML_vertical_line(X+3,Y-1,Y+1,ML_BLACK);
		ML_horizontal_line(Y-3,X-1,X+1,ML_BLACK);
		ML_horizontal_line(Y+3,X-1,X+1,ML_BLACK);
		
		ML_pixel(X-2,Y-2,ML_BLACK);
		ML_pixel(X+2,Y-2,ML_BLACK);
		ML_pixel(X-2,Y+2,ML_BLACK);
		ML_pixel(X+2,Y+2,ML_BLACK);
		
		for(i=0;i<5;i++)
		{
			x=alea(X-5,X+6);
			do
			{
				y=alea(Y-5,Y+6);
			}while(DISTANCE(x,y,X,Y)>8);
			ML_pixel(x,y,ML_BLACK);
		}
		
		pointeur=texte6;
		if(RTC_getTicks()-temps>5*128)pointeur=texte7;	//Le second texte s'affiche au bout de 5 secondes
		
		fenetre(3,VRAI,1,pointeur);
		ML_display_vram();
		Sleep(100);
	}
	
	X=40;
	Y=30;

	ML_clear_vram();
	ML_filled_ellipse(X,Y,4,14,ML_BLACK);
	ML_filled_random_ellipse(X,Y,12,28,10);
	for(i=0;i<NOMBRE_POINTS/2;i++)ML_pixel(alea(0,127),alea(0,63),ML_BLACK);
	ML_display_vram();
	Sleep(1000);
	
	x=126;
	y=1;
	x_cible=X;
	condition=FAUX;
	
	temps=RTC_getTicks();
	while(x_cible!=x || Y!=y)
	{
		if(condition)
		{
			if(x>=X-1)ML_pixel(x+1,y,ML_XOR);
			if(x>X)ML_pixel(x-1,y,ML_XOR);
			if(x>=X)ML_pixel(x,y+1,ML_XOR);
			if(x>=X)ML_pixel(x,y-1,ML_XOR);
		}
		
		if(alea(0,7) || x<2 || x>125 || y<2 || y>61)
		{
			if(!alea(0,2))y+=(y<Y)-(y>Y);
			x+=(x<x_cible)-(x>x_cible);
		}
		else
		{
			i=alea(1,4);
			x+=(i==4)-(i==2);
			y+=(i==3)-(i==1);
		}
		if(y==Y && x==x_cible && x_cible==40)x_cible-=2;
		
		if(x>=X-1)ML_pixel(x+1,y,ML_XOR);
		if(x>X)ML_pixel(x-1,y,ML_XOR);
		if(x>=X)ML_pixel(x,y+1,ML_XOR);
		if(x>=X)ML_pixel(x,y-1,ML_XOR);
		
		pointeur=texte8;
		if(RTC_getTicks()-temps>=4*128)pointeur=texte9;
		if(RTC_getTicks()-temps>=8*128)pointeur=texte10;
		fenetre(3,VRAI,1,pointeur);
		
		ML_display_vram();
		condition=VRAI;
		Sleep(139);
	}
	
	ML_clear_screen();
	Sleep(50);
	ML_rectangle(0,0,127,63,0,ML_BLACK,ML_BLACK);
	ML_display_vram();
	Sleep(100);
	ML_clear_screen();
	Sleep(2000);
}

void premiere_visite_magasin()
{
	char texte1[]="Les pouvoirs se regroupent en/six categories, en fonction de/l'energie exploitee.\0",
		 texte2[]="L'ENERGIE VIBRATILE permet/d'utiliser des pouvoirs a effet/de zone, comme des auras\0",
		 texte3[]="L'ENERGIE METAPHYSIQUE, en/modifiant votre nature, peut/vous rendre insaisissable\0",
		 texte4[]="L'ENERGIE TRANSCENDANTE/exploite votre potentiel pour/vous soigner ou vous/renforcer\0",
		 texte5[]="L'ENERGIE RESIDUELLE permet/de causer des degats, grace a/l'energie qui s'accumule un peu/partout autour de vous\0",
		 texte6[]="L'ENERGIE CHAOTIQUE utilise les/forces chaotiques ambiantes/pour semer la confusion\0",
		 texte7[]="L'ENERGIE PSYCHIQUE explore/les trefonds de l'esprit pour/manipuler vos ennemis\0",
		 texte8[]="Chaque energie propose trois/pouvoirs, classes dans une/arborescence\0",
		 texte9[]="Ainsi, vous ne pourrez choisir/qu'un pouvoir par categorie./Utilisez SHIFT pour acheter et/selectionner des pouvoirs\0",
		 texte10[]="A chaque categorie est/attribuee une touche, de F1 a/F6.";
		 
	fenetre(4,VRAI,0,texte1);
	fenetre(4,VRAI,0,texte2);
	fenetre(4,VRAI,0,texte3);
	fenetre(4,VRAI,0,texte4);
	fenetre(4,VRAI,0,texte5);
	fenetre(4,VRAI,0,texte6);
	fenetre(4,VRAI,0,texte7);
	fenetre(4,VRAI,0,texte8);
	fenetre(4,VRAI,0,texte9);
	fenetre(4,VRAI,0,texte10);
}

void pretre_surpris_salle1(Donnees *donnees,Map *map,General *general)
{
	char texte1[100]="PRETRE : Un... un demon ! Une/ame dechue des limbes de/l'oubli !\0",
		 texte2[100]="Ce pretre n'a pas l'air tres/amical... il va falloir s'en/debarasser./Utilisons un pouvoir.\0",
		 texte3[100]="Appuyez sur F4 pour/localiser une source/d'energie\0",
		 texte4[100]="Cette source me semble un/peu trop eloignee.../refaites un essai\0",
		 texte5[100]="C'est mieux ! Appuyez sur/SHIFT\0",
		 texte6[100]="Bien joue ! A present,/utilisez les touches/flechees pour sortir...\0",
		 texte7[100]="...par la porte a droite\0";

	Etre *etre=&map->etres[3];
	Pouvoir *pouvoir=&general->pouvoirs[DECHARGE_ENERGIE];
	
	ML_clear_vram();
	affichage_map(map,general);

	surpris(6,0,VRAI);
	ML_display_vram();
	Sleep(1000);
	affichage_carre(6,0,ML_WHITE,VRAI);
	
	fenetre(4,VRAI,0,texte1);
	
	etre->mode=1;
	ML_clear_vram();
	affichage_map(map,general);
	fenetre(4,VRAI,0,texte2);
	
	general->pouvoirs_choisis[RESIDUELLE]=pouvoir;
	RAFRAICHISSEMENT
	fenetre(4,FAUX,KEY_CTRL_F4,texte3);
	
	general->zoom=FAUX;
	general->x_source=2;
	general->y_source=1;
	general->etape=1;
	RAFRAICHISSEMENT
	fenetre(3,FAUX,KEY_CTRL_F4,texte4);
	
	general->x_source=5;
	general->y_source=3;
	RAFRAICHISSEMENT
	fenetre(3,FAUX,KEY_CTRL_SHIFT,texte5);
	
	effet_continu(map,general,pouvoir,0);
	RAFRAICHISSEMENT
	Sleep(200);
	general->etape=0;
	etre->vivant=FAUX;
	donnees->presence_etres[0]=0;
	RAFRAICHISSEMENT
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	
	pouvoir->utilisation=pouvoir->temps_utilisation;
	pouvoir->etat=INACTIF;
	general->pouvoirs_choisis[RESIDUELLE]=NULL;
}

void infiltration_salle2(Map *map,General *general)
{
	char texte1[]="Ces gardes fanatiques ont l'air/coriaces... Il va falloir faire/preuve de discretion\0",
		 texte2[]="Appuyez sur F2 afin/d'utiliser l'energie/metaphysique. Elle vous/rendra invisible\0",
		 texte3[]="Bien. Vous pouvez vous/deplacer sans crainte a/present\0",
		 texte4[]="Parfait. Vous voici a present/face a une source d'ether.\0",
		 texte5[]="Elle vous permet de vous/soigner et d'acquerir de/nouveaux pouvoirs\0",
		 texte6[]="Ces derniers s'achetent avec/des larmes sacrees, qui/peuvent se trouver un peu/partout dans le temple\0",
		 texte7[]="Pour acceder au magasin,/positionnez-vous devant une/source d'ether et appuyez sur/ALPHA\0",
		 texte8[]="Retenez egalement les touches/suivantes : SHIFT permet de/changer le zoom...\0",
		 texte9[]="...OPTN permet d'acceder a un/recapitulatif de votre vie et/de vos pouvoirs...\0",
		 texte10[]="...et MENU permet de/retourner au menu en/sauvegardant votre partie\0";
	char i;
	unsigned int key;
	Pouvoir *pouvoir=&general->pouvoirs[FUGACITE];
	
	general->zoom=VRAI;
	general->regard=1;
	ML_clear_vram();
	affichage_map(map,general);
	ML_display_vram();
	Sleep(1000);
	fenetre(4,VRAI,0,texte1);
	
	
	general->pouvoirs_choisis[METAPHYSIQUE]=pouvoir;
	RAFRAICHISSEMENT
	fenetre(4,FAUX,KEY_CTRL_F2,texte2);
	
	utilisation_pouvoir(map,general,general->pouvoirs_choisis);
	RAFRAICHISSEMENT
	fenetre(4,FAUX,0,texte3);
	
	RAFRAICHISSEMENT
	
	for(i=0;i<4;i++)
	{
		while(!DROITE)Sleep(100);
		general->x++;
		pouvoir->utilisation-=VITESSE_MAX;
		RAFRAICHISSEMENT
		while(DROITE)Sleep(100);
	}
	
	pouvoir->utilisation=pouvoir->temps_utilisation;
	pouvoir->etat=INACTIF;
	general->pouvoirs_choisis[METAPHYSIQUE]=NULL;
	general->fugace=FAUX;
	
	RAFRAICHISSEMENT
	
	fenetre(4,VRAI,0,texte4);
	fenetre(4,VRAI,0,texte5);
	fenetre(4,VRAI,0,texte6);
	fenetre(4,VRAI,0,texte7);
	fenetre(4,VRAI,0,texte8);
	fenetre(4,VRAI,0,texte9);
	fenetre(4,VRAI,0,texte10);
}

void encerclement_salle14(Donnees *donnees,Map *map,General *general)
{
	char i,texte1[100]="FANATIQUE :/Pourfendez-le !\0";
	
	general->zoom=VRAI;
	RAFRAICHISSEMENT
	Sleep(750);
	for(i=0;i<2;i++)
	{
		deplacement(map,3,&general->x,&general->y,&general->direction,FAUX,FAUX);
		RAFRAICHISSEMENT
		Sleep(400);
	}
	
	surpris(3,0,VRAI);
	ML_display_vram();
	Sleep(1000);
	RAFRAICHISSEMENT
	fenetre(4,FAUX,0,texte1);
	
	general->alerte=VRAI;
	
	for(i=0;i<25;i++)
	{
		map->etres[15].precision_max=0;
		gestion_etres(map,general);
		
		ML_clear_vram();
		affichage_map(map,general);
		affichage_barres_pouvoir(general->pouvoirs_choisis);
		if(i>=8 && ((i/4)&1))inversion_ecran();
		ML_display_vram();
		
		setFps(6);
	}
	
	NEGATIF(150);
	NEGATIF(150);
	NEGATIF(1000);
	
	general->salle=9;
	generation_map(map,9,donnees);
	grande_pretresse_salle9(map,general,1);
}

void encerclement_salle5(Donnees *donnees,Map *map,General *general)
{
	Etre *etre;
	char i,texte1[]="HIEROPHANTE : Le demon !/Exorcisez-le !\0";
	
	general->zoom=VRAI;
	
	for(i=9;i<=12;i++)
	{
		etre=&map->etres[i];
		etre->x=1+((i-9)&1);
		etre->y=3+2*(i>10);
		etre->direction=3-2*(i>10);
		etre->mode=1;
	}

	etre=&map->etres[15];		//Hiérophante
	etre->x=4;
	etre->y=4;
	etre->direction=4;
	
	RAFRAICHISSEMENT
	Sleep(1000);
	fenetre(4,FAUX,0,texte1);
	
	RAFRAICHISSEMENT
	
	
	NEGATIF(1000);
	NEGATIF(150);
	
	NEGATIF(100);
	NEGATIF(50);
	NEGATIF(100);
	NEGATIF(50);
	
	NEGATIF(1000);
	
	general->y=3;
	general->x=6;
	general->salle=9;
	generation_map(map,9,donnees);
	grande_pretresse_salle9(map,general,0);
}

void grande_pretresse_salle9(Map *map,General *general,char mode)
{
	/*
		mode=0 : sauve de la garde du hierophante
		mode=1 : sauve de la garde des reliques
	*/

	Etre *pretresse=&map->etres[3];
	char texte1[]="EDASTHEREBE : Qui... qui/etes-vous ?\0",
		 texte2[]="PRETRESSE : Tu ignores qui/je suis mais je sais qui tu/es. N'aies crainte, je suis/la grande pretresse\0",
		 texte3[]="J'ai ressenti ta presence/et, ayant percu le danger,/je t'ai sauve en te/teleportant ici.\0",
		 texte4_1[]="En effet, tu t'es fait/attaquer par la garde des/reliques\0",
		 texte4_2[]="Ces fanatiques obeissent/directement au grand/hierophante\0",
		 texte4_3[]="En effet, tu t'es aventure/dans l'aile des pretres, et/tu es tombe sur le grand/hierophante en personne\0",
		 texte5[]="Tu as voulu gouter a/l'aventure, mais tu n'es/pas le bienvenu ici. Ils te/prennent pour un demon\0",
		 texte6[]="Si tu veux fuir d'ici, tu/dois trouver un autre/tunnel metaphysique.\0",
		 texte7[]="Le seul qui existe ici est/la source divine. Elle se/situe dans l'aile sacree,/qui est tres bien protegee\0",
		 texte8[]="On ne peut y acceder que/depuis la salle du/hierophante\0",
		 texte9[]="Je sais qui peux t'aider :/le paladin. Il est detenu/dans la prison, a l'Est\0",
		 texte10[]="Continue a droite, apres/quoi je t'ouvrirai une/porte secrete vers les/souterrains\0",
		 texte11[]="Bonne chance.../Edastherebe\0";
	
	
	general->alerte=FAUX;
	
	RAFRAICHISSEMENT
	Sleep(500);
	general->direction=1;
	RAFRAICHISSEMENT
	
	fenetre(4,FAUX,0,texte1);
	fenetre(4,FAUX,0,texte2);
	fenetre(4,FAUX,0,texte3);
	if(mode)
	{
		fenetre(4,FAUX,0,texte4_1);
		fenetre(4,FAUX,0,texte4_2);
	}
	else fenetre(4,FAUX,0,texte4_3);
	fenetre(4,FAUX,0,texte5);
	fenetre(4,FAUX,0,texte6);
	fenetre(4,FAUX,0,texte7);
	fenetre(4,FAUX,0,texte8);
	fenetre(4,FAUX,0,texte9);
	fenetre(4,FAUX,0,texte10);
	fenetre(4,FAUX,0,texte11);
}

void souterrain_salle11(Map *map,General *general)
{
	short i;
	char texte1[]="Evadez-vous via le/souterrain secret...";
	general->zoom=VRAI;
	
	for(i=800;i;i-=100-90*(i<=100)-9*(i<=10))
	{
		MAP(1,7)=MUR2_FACE;
		RAFRAICHISSEMENT
		Sleep(i);
		MAP(1,7)=PORTE2_FACE;
		RAFRAICHISSEMENT
		Sleep(50);
	}
	
	Sleep(1000);
	fenetre(3,FAUX,0,texte1);
}

void discretion_salle20(Map *map,General *general)
{
	char i;
	char texte1[]="Il semblerait qu'il y ait/beaucoup de monde ici.../je ferais mieux de trouver/une autre issue\0";
	
	general->zoom=FAUX;
	general->regard=1;
	
	for(i=0;i<80;i++)
	{
		gestion_etres(map,general);
		RAFRAICHISSEMENT
		GESTION_TEMPS
		
		if(i==40)general->zoom=VRAI;
	}
	
	fenetre(4,FAUX,0,texte1);
}

void rencontre_paladin_salle7(Map *map,General *general)
{
	char texte1[]={"PALADIN : Une... une ame/perdue ! Que fais-tu la ?\0"},
		 texte2[]={"EDASTHEREBE : C'est la/grande pretresse du/temple qui m'envoie\0"},
		 texte3[]={"Vous etes bien le premier/que je vois qui ne me/prend pas pour un demon !\0"},
		 texte4[]={"PALADIN : Ha ha ha ! Ce ne/serait pas la premiere fois/que ces...\0"},
		 texte5[]={"...fanatiques soient/aveugles par leur mythes\0"},
		 texte6[]={"Mais je suis d'une autre/trempe que ces clampins/endoctrines.\0"},
		 texte7[]={"Je suis... le paladin !\0"},
		 texte8[]={"Le hierophante m'a/emprisonne pour un motif/fallacieux.\0"},
		 texte9[]={"Mais je sais qu'en realite,/il me redoute\0"},
		 texte10[]={"La grande pretresse.../alors comme ca nous avons/un soutien en ces murs ?\0"},
		 texte11[]={"C'est peut-etre le/moment opportun pour/s'evader.\0"},
		 texte12[]={"Malheureusement, je suis/trop affaibli pour forcer/la rebellion\0"},
		 texte13[]={"Si je veux detruire ces/grilles, je dois exploiter/ta force vitale\0"},
		 texte14[]={"Acceptes-tu ?\0"},
		 texte15[]={"EDASTHEREBE : Oui ! Je/pense que vous etes ma cle/pour la liberte\0"},
		 texte16[]={"Si nous renversons ce/hierophante, je pourrais/acceder a la source divine\0"},
		 texte17[]={"PALADIN : Parfait ! L'heure/de la revolte a sonne !\0"},
		 texte18[]={"Bien. Notre objectif est/la source d'ether, au sud.\0"},
		 texte19[]={"Je pourrai y refaire mes/forces. Apres quoi, nous/preparerons un plan\0"};
	char i,j;
	general->zoom=VRAI;
	
	map->etres[10].mode=2;
	while(general->y!=3)
	{
		RAFRAICHISSEMENT
		Sleep(400);
		deplacement(map,1,&general->x,&general->y,&general->direction,FAUX,FAUX);
		general->regard=0;
	}
	
	RAFRAICHISSEMENT
	Sleep(1000);
	
	fenetre(3,FAUX,0,texte1);
	fenetre(3,FAUX,0,texte2);
	fenetre(3,FAUX,0,texte3);
	fenetre(3,FAUX,0,texte4);
	fenetre(3,FAUX,0,texte5);
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	fenetre(3,FAUX,0,texte8);
	fenetre(3,FAUX,0,texte9);
	fenetre(3,FAUX,0,texte10);
	fenetre(3,FAUX,0,texte11);
	fenetre(3,FAUX,0,texte12);
	fenetre(3,FAUX,0,texte13);
	fenetre(3,FAUX,0,texte14);
	fenetre(3,FAUX,0,texte15);
	fenetre(3,FAUX,0,texte16);
	fenetre(3,FAUX,0,texte17);

	for(i=70;i>40;i--)
	{
		NEGATIF(i);
	}
	
	ML_clear_screen();
	Sleep(1000);
	general->alerte=VRAI;
	for(i=0;i<map->nombre_etres;i++)map->etres[i].mode=1;
	for(i=4;i<9;i++)for(j=2;j<6;j++)if(MAP(i,j)==GRILLE_FACE || MAP(i,j)==GRILLE_COTE)MAP(i,j)=RIEN;
	general->vie-=50;
	if(general->vie<=0)general->vie=10;
	RAFRAICHISSEMENT
	
	fenetre(3,FAUX,0,texte18);
	fenetre(3,FAUX,0,texte19);
}

void assaut_salle19(Map *map,General *general)
{
	char i;
	Etre *etre;
	
	for(i=8;i<map->nombre_etres;i++)
	{
		etre=&map->etres[i];
		etre->vivant=FAUX;
		etre->cache=VRAI;
		etre->repulsion_x=etre->x;
		etre->repulsion_y=etre->y;
	}
	
	MAP(6,1)=PERSONNAGE;
}

void bilan_assaut_salle19(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="PALADIN : Cet assaut etait/parfait.On a eu le gain de/l'effet de surprise\0",
		 texte2[]="Nous devons immediatement/reprendre l'attaque./Tous a la salle sud !\0";

	generation_map(map,19,donnees);
	general->x=8;
	general->y=4;
	general->direction=2;
	
	general->zoom=VRAI;
	general->regard=1;
	
	RAFRAICHISSEMENT
	fenetre(3,FAUX,0,texte1);
	fenetre(3,FAUX,0,texte2);
}

void assaut_salle25(Map *map,General *general)
{
	char i;
	Etre *etre;
	
	for(i=21;i<map->nombre_etres;i++)
	{
		etre=&map->etres[i];
		etre->vivant=FAUX;
		etre->cache=VRAI;
		etre->repulsion_x=etre->x;
		etre->repulsion_y=etre->y;
	}
	
	general->y=2;
	MAP(7,2)=PERSONNAGE;
}

void bilan_assaut_salle25(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="PALADIN : Je ressent la/source... elle me redonne/des forces\0",
		 texte2[]="A present, je sais qui peut/nous aider\0",
		 texte3[]="Le hierophante a obtenu sa/place grace a des complots/et des manigances\0",
		 texte4[]="L'ancien hierophante,/injustement chasse, ne/s'est pas enfui\0",
		 texte5[]="Il se terre dans les/souterrains, attendant son/heure\0",
		 texte6[]="Infiltre-toi dans les/lignes ennemies, et/regagne les souterrains.\0",
		 texte7[]="Tu y trouveras une statue/d'un dieu.\0",
		 texte8[]="Elle recele un mecanisme/cache, que peu de/personnes connaissent\0",
		 texte9[]="Lorsque tu auras trouve la/cachette de/l'ex-hierophante...\0",
		 texte10[]="..il te faudra le/convaincre que le moment/est venu de se venger\0",
		 texte11[]="Nous reverrons apres./Bonne chance !\0";

	generation_map(map,25,donnees);
	general->x=4;
	general->y=6;
	general->direction=1;
	
	general->zoom=VRAI;
	general->regard=0;
	
	RAFRAICHISSEMENT
	
	fenetre(3,FAUX,0,texte1);
	fenetre(3,FAUX,0,texte2);
	fenetre(3,FAUX,0,texte3);
	fenetre(3,FAUX,0,texte4);
	fenetre(3,FAUX,0,texte5);
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	fenetre(3,FAUX,0,texte8);
	fenetre(3,FAUX,0,texte9);
	fenetre(3,FAUX,0,texte10);
	fenetre(3,FAUX,0,texte11);
}

void activation_statue_salle23(Map *map,General *general)
{
	char texte1[]="Le mecanisme de la statue/s'active...\0",
		 texte2[]="Le bruit d'une porte qui/s'ouvre lentement se fait/entendre\0";

	general->zoom=VRAI;
	RAFRAICHISSEMENT
	Sleep(1000);

	deplacement(map,1,&general->x,&general->y,&general->direction,FAUX,FAUX);
	general->regard=1;
	RAFRAICHISSEMENT
	Sleep(200);

	Sleep(1000);
	fenetre(3,FAUX,0,texte1);
	fenetre(3,FAUX,0,texte2);
}

void rencontre_ex_hierophante(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="EX-HIEROPHANTE : Que/fais-tu la, creature de/l'ether ?\0",
		 texte2[]="Voila des annees que/personne n'est venu/troubler ma solitude pour/contempler ma decheance\0",
		 texte3[]="Parle, si tu en es/capable ! J'ai oublie le son/de toute voix autre que la/mienne depuis longtemps\0",
		 texte4[]="EDASTHEREBE : Calmez-vous !/Je me nomme edastherebe,/c'est le paladin qui/m'envoie vous querir\0",
		 texte5[]="Il a declenche une revolte,/et il juge que c'est le/moment propice pour que/vous nous veniez en aide\0",
		 texte6[]="Nous pourrions nous/introduire furtivement/dans la salle ou siege le/hierophante\0",
		 texte7[]="Rendez-vous compte, vous/pourriez triompher de/votre rival !\0",
		 texte8[]="EX-HIEROPHANTE : Ce/paladin... il n'a pas/change.\0",
		 texte9[]="Il a oublie mon age.../je suis trop vieux pour/prendre de tels risques.\0",
		 texte10[]="Si je sort d'ici, la/ribambelle de fideles du/hierophante m'executera/sur-le-champ\0",
		 texte11[]="Non, vraiment...\0",
		 texte12[]="Attends un peu...\0",
		 texte13[]="Sais-tu que tu corresponds/a la description que/certains mythes anciens/font...\0",
		 texte14[]="...des demons des mondes/infernaux ?\0",
		 texte15[]="EDASTHEREBE : Oui... je l'ai/appris a mes depends\0",
		 texte16[]="EX-HIEROPHANTE : Il me/vient une idee... Que/dirais-tu de faire une/diversion fracassante ?\0",
		 texte17[]="Si tu occupes les pretres/qui prient pres de la salle/du hierophante...\0",
		 texte18[]="...je pourrais regler le/compte de ce rapace sans/etre importune !\0",
		 texte19[]="EDASTHEREBE : ce me parait/etre une bonne idee...\0",
		 texte20[]="EX-HIEROPHANTE : Parfait !/Je vais te deplacer pres/de l'aile des pretres\0",
		 texte21[]="Tu y feras diversion, et tu/tiendras assez longtemps,/le temps que je coince/mon ennemi\0",
		 texte22[]="Apres quoi, je te/recupererai. Je ne tiens/pas a ce que tu fasses une/diversion-suicide...\0",
		 texte23[]="Es-tu pret ?\0";
	char i; 
	
	general->zoom=FAUX;	
	RAFRAICHISSEMENT
	Sleep(1000);
	
	general->zoom=VRAI;
	RAFRAICHISSEMENT
	Sleep(500);
	
	general->direction=2;	
	RAFRAICHISSEMENT
	Sleep(500);
	
	fenetre(4,FAUX,0,texte1);
	fenetre(4,FAUX,0,texte2);
	fenetre(4,FAUX,0,texte3);
	fenetre(4,FAUX,0,texte4);
	fenetre(4,FAUX,0,texte5);
	fenetre(4,FAUX,0,texte6);
	fenetre(4,FAUX,0,texte7);
	fenetre(4,FAUX,0,texte8);
	fenetre(4,FAUX,0,texte9);
	fenetre(4,FAUX,0,texte10);
	fenetre(4,FAUX,0,texte11);
	RAFRAICHISSEMENT
	Sleep(1000);
	fenetre(4,FAUX,0,texte12);
	fenetre(4,FAUX,0,texte13);
	fenetre(4,FAUX,0,texte14);
	fenetre(4,FAUX,0,texte15);
	fenetre(4,FAUX,0,texte16);
	fenetre(4,FAUX,0,texte17);
	fenetre(4,FAUX,0,texte18);
	fenetre(4,FAUX,0,texte19);
	fenetre(4,FAUX,0,texte20);
	fenetre(4,FAUX,0,texte21);
	fenetre(4,FAUX,0,texte22);
	fenetre(4,FAUX,0,texte23);
	
	RAFRAICHISSEMENT
	Sleep(500);
	for(i=0;i<7;i++)
	{
		NEGATIF(100);
	}
	Sleep(1000);
	
	general->salle=2;
	general->x=10;
	general->y=4;
	generation_map(map,2,donnees);
}

void diversion_salle4(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="EDASTHEREBE : Je suis/Edastherebe, progeniture/du chaos, hanteur des/limbes de l'oubli !\0",
		 texte2[]="Tremblez, pauvres fous !\0";
	char i;
	Etre *etre;
	
	general->zoom=VRAI;
	general->regard=1;
	RAFRAICHISSEMENT
	
	Sleep(1000);
	general->alerte=VRAI;
	for(i=3;i<map->nombre_etres;i++)
	{
		etre=&map->etres[i];
		if(etre->direction==1)etre->direction=3;
		else etre->direction=1;
	}
	RAFRAICHISSEMENT
	fenetre(4,FAUX,0,texte1);
	RAFRAICHISSEMENT
	fenetre(2,FAUX,0,texte2);
}

void affrontement_salle5(Map *map,General *general,Donnees *donnees)
{
	char dialogue[10][200]={"EX-HIEROPHANTE : Tu te/souviens de ce jour ou tu/m'as banni, de ce jour...\0",
						   "...ou tu m'as traine sur/les marches du temple ?\0",
						   "Longtemps je me suis/promis une juste revanche,/longtemps j'ai attendu !\0",
						   "Jusqu'a aujourd'hui !\0",
						   "HIEROPHANTE : Ahah ah ah/ah !\0",
						   "Epargne-moi ton discours/heroique ! Ma garde est en/train de nettoyer...\0",
						   "...la racaille qui s'est/evadee de mes prisons.\0",
						   "Je pourrais perdre mon/temps a vous eliminer, toi/et ton serviteur\0",
						   "Cependant vous me faites/pitie, et j'ai d'autres/projets plus interessants\0",
						   "Nous nous reverrons,/pauvre vieillard !\0"};
	char i,j,texte;
	int temps;
	
	short salles[]={20,25,26};
	reinitialisation_salle(salles,3,donnees);
	
	Sleep(500);
	for(i=0;i<7;i++)
	{
		NEGATIF(100);
	}
	Sleep(1000);
	
	general->salle=5;
	generation_map(map,5,donnees);
	for(i=1;i<LARGEUR-1;i++)for(j=1;j<HAUTEUR-1;j++)MAP_FUMEE(i,j)=(MAP(i,j)<10 || MAP(i,j)==ETRE);
	for(i=6;i<=8;i++)for(j=2;j<=4+(i==7);j++)MAP_FUMEE(i,j)=0;
	
	general->regard=0;
	general->zoom=VRAI;
	general->x=6;
	general->y=4;
	general->direction=1;
	general->alerte=VRAI;
	
	temps=RTC_getTicks();
	while(RTC_getTicks()-temps<128*2)
	{
		gestion_etres(map,general);
		RAFRAICHISSEMENT
		GESTION_TEMPS
	}
	
	texte=0;
	while(texte<10)
	{
		do
		{
			gestion_etres(map,general);
			ML_clear_vram();
			affichage_map(map,general);
			affichage_barres_pouvoir(general->pouvoirs_choisis);
			fenetre(3,FAUX,1,dialogue[texte]);
			GESTION_TEMPS
		}while(!EXE);
		
		while(EXE)Sleep(100);
		texte++;
	}
	
	RAFRAICHISSEMENT
	NEGATIF(100);
	NEGATIF(100);
	ML_clear_vram();
	ML_display_vram();
	Sleep(2000);
	
	donnees->mission++;
	bilan_salle5(map,general,donnees);
}

void bilan_salle5(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="EX-HIEROPHANTE :/Edastherebe ! Vous allez/bien ?\0",
		 texte2[]="EDASTHEREBE : Que... que/s'est-il passe ?\0",
		 texte3[]="EX-HIEROPHANTE : Ce lache/s'est enfui ! Il a du se/barricader dans l'aile/sacree\0",
		 texte4[]="VOIX : Alors, allons l'en/deloger\0",
		 texte5[]="EX_HIEROPHANTE : La grande/pretresse... ainsi, vous/nous apportez votre aide ?\0",
		 texte6[]="GRANDE PRETRESSE : Mais je/suis votre alliee depuis le/debut...\0",
		 texte7[]="C'est moi qui ai mene/Edastherebe jusq'au/Paladin.\0",
		 texte8[]="Je me doutais bien qu'il/n'aurait pas manque une/telle occasion de s'evader\0",
		 texte9[]="Puisqu'on parle de lui, son/aide nous serait precieuse/pour l'assaut final\0",
		 texte10[]="Vous voulez bien aller le/chercher ?\0";
	char i;
	Etre *hierophante=&map->etres[3];
	
	generation_map(map,5,donnees);
	
	general->y=2;
	general->direction=2;
	general->regard=1;
	general->alerte=FAUX;
	
	for(i=4;i<=6;i++)map->etres[i].vivant=FAUX;
	
	fenetre(3,FAUX,0,texte1);
	RAFRAICHISSEMENT
	Sleep(500);
	fenetre(3,FAUX,0,texte2);
	fenetre(4,FAUX,0,texte3);
	RAFRAICHISSEMENT
	fenetre(3,FAUX,0,texte4);
	
	for(i=4;i<=6;i++)map->etres[i].vivant=VRAI;
	
	general->direction=3;
	hierophante->direction=3;
	RAFRAICHISSEMENT
	Sleep(500);
	
	deplacement(map,3,&general->x,&general->y,&general->direction,FAUX,FAUX);
	MAP(hierophante->x,hierophante->y)=RIEN;
	deplacement(map,3,&hierophante->x,&hierophante->y,&hierophante->direction,FAUX,FAUX);
	MAP(hierophante->x,hierophante->y)=ETRE;
	hierophante->patrouille[0]=hierophante->x;
	hierophante->patrouille[1]=hierophante->y;
	hierophante->direction_originelle=3;
	
	RAFRAICHISSEMENT
	Sleep(1000);
	
	fenetre(3,FAUX,0,texte5);
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	fenetre(3,FAUX,0,texte8);
	fenetre(3,FAUX,0,texte9);
	fenetre(3,FAUX,0,texte10);
}

void rencontre_paladin_salle14(Map *map,General *general)
{
	char texte1[]="PALADIN : Ah, Edastherebe !/Vous voila enfin\0",
		 texte2[]="EDASTHEREBE : Mais... que/s'est-il passe ? Que/faites-vous ici ?\0",
		 texte3[]="PALADIN : Ils ont/contre-attaque en force/et nous ont repousse ici...\0",
		 texte4[]="J'ai perdu la moitie de mes/hommes. Nous ne/tiendrons pas longtemps\0",
		 texte5[]="EDASTHEREBE : Gardez/espoir ! Nous avons/attaque le hierophante\0",
		 texte6[]="Il s'est retranche dans/son aile avec ses pretres\0",
		 texte7[]="La grande pretresse est/arrivee, nous n'attendons/plus que vous\0",
		 texte8[]="PALADIN : Excellente/nouvelle ! Je vais les/rejoindre immediatement\0";
	char i,nombre_vivants=map->nombre_etres-3;
	short compteur=1;
	Etre *etre;
	
	general->regard=1;
	MAP(general->x,general->y)=RIEN;
	
	while(general->y < 4)
	{
		RAFRAICHISSEMENT
		Sleep(500);
		deplacement(map,3,&general->x,&general->y,&general->direction,FAUX,FAUX);
	}

	MAP(general->x,general->y)=PERSONNAGE;
	
	if(general->y==6)map->etres[3].direction=3;
	RAFRAICHISSEMENT
	Sleep(500);
	
	fenetre(3,FAUX,0,texte1);
	fenetre(3,FAUX,0,texte2);
	fenetre(3,FAUX,0,texte3);
	fenetre(3,FAUX,0,texte4);
	fenetre(3,FAUX,0,texte5);
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	fenetre(3,FAUX,0,texte8);
	
	general->zoom=FAUX;
	
	while(nombre_vivants)
	{	
		gestion_etres(map,general);
		for(i=3;i<map->nombre_etres;i++)
		{
			etre=&map->etres[i];
			if(etre->vivant && etre->x==6 && etre->y==1 && etre->compteur==etre->vitesse-1)
			{
				etre->vivant=FAUX;
				nombre_vivants--;
				MAP(etre->x,etre->y)=RIEN;
			}
		}
		
		if(!compteur)
		{
			if(!MAP(7,4) && general->y==4)
			{
				MAP(general->x,general->y)=RIEN;
				deplacement(map,2,&general->x,&general->y,&general->direction,FAUX,FAUX);
				MAP(general->x,general->y)=PERSONNAGE;
			}
			else general->direction=4;
		}
		compteur=gestion_vitesse(compteur,VITESSE_MAX);
		
		RAFRAICHISSEMENT
		GESTION_TEMPS
	}
}

void preparatifs_salle5(Map *map,General *general)
{
	char texte1[]="EX-HIEROPHANTE : Tout est/pret. Nous vous suivons";

	general->regard=1;
	general->zoom=VRAI;
	
	RAFRAICHISSEMENT
	Sleep(1000);
	
	fenetre(3,FAUX,0,texte1);
}

void assaut_final(Map *map,General *general)
{
	char texte1[]="PALADIN : sus au/hierophante !\0";
	char i;
	Etre *etre;
	
	for(i=0;i<64;i++)
	{
		ML_horizontal_line(i,0,127,ML_BLACK);
		ML_display_vram();
		Sleep(20);
	}
	
	MAP(general->x,general->y)=RIEN;
	general->x=4;
	MAP(general->x,general->y)=PERSONNAGE;
	
	general->zoom=FAUX;
	general->alerte=VRAI;
	for(i=3;i<map->nombre_etres;i++)
	{
		etre=&map->etres[i];
		if(etre->type!=HIEROPHANTE && etre->type!=GRANDE_PRETRESSE)etre->mode=1;
	}
	
	for(i=0;i<64;i++)
	{
		ML_clear_vram();
		affichage_map(map,general);
		affichage_barres_pouvoir(general->pouvoirs_choisis);
		ML_rectangle(0,i,127,63,0,ML_BLACK,ML_BLACK);
		ML_display_vram();
		Sleep(20);
	}
	
	fenetre(3,FAUX,0,texte1);
}

void conclusion(Map *map,General *general,Donnees *donnees)
{
	char texte1[]="EX-HIEROPHANTE : Victoire !/Le hierophante est tombe\0",
		 texte2[]="EDASTHEREBE : Ainsi, nos/chemins se separent. Ce/temple est en paix\0",
		 texte3[]="GRANDE PRETRESSE : Oui,/vous ferez un bien/meilleur hierophante\0",
		 texte4[]="EDASTHEREBE : Quant a/vous, messire le paladin,/vous voila de nouveau libre\0",
		 texte5[]="PALADIN : Je pense rester/au service du nouveau/hierophante.\0",
		 texte6[]="J'effectuerai des quetes/pour trouver des reliques/precieuses\0",
		 texte7[]="EDASTHEREBE : Je vais/pouvoir rentrer dans mon/monde\0",
		 texte8[]="Adieu\0",
		 texte9[]="Ainsi Edastherebe trouva la/paix, ayant vecu tant de choses/a mediter\0",
		 texte10[]="Jusqu'a sa prochaine/incarnation...\0";
	char *pointeur;
	int temps;
	short points[NOMBRE_POINTS/4];
	short i,x,y,X=63,Y=20;
		
	fenetre(3,FAUX,0,texte1);
	
	generation_map(map,6,donnees);
	
	general->direction=3;
	general->x=11;
	general->y=3;
	general->regard=1;
	general->zoom=VRAI;
	general->alerte=FAUX;
	
	RAFRAICHISSEMENT
	Sleep(2000);
	
	fenetre(3,FAUX,0,texte2);
	map->etres[3].direction=2;
	map->etres[4].direction=4;
	map->etres[5].direction=4;
	RAFRAICHISSEMENT
	fenetre(3,FAUX,0,texte3);
	map->etres[3].direction=1;
	map->etres[4].direction=1;
	map->etres[5].direction=1;
	RAFRAICHISSEMENT
	fenetre(3,FAUX,0,texte4);
	fenetre(3,FAUX,0,texte5);
	fenetre(3,FAUX,0,texte6);
	fenetre(3,FAUX,0,texte7);
	fenetre(3,FAUX,0,texte8);
	
	RAFRAICHISSEMENT
	Sleep(500);
	
	deplacement(map,1,&general->x,&general->y,&general->direction,FAUX,FAUX);
	general->regard=0;
	
	temps=RTC_getTicks();
	while(RTC_getTicks()-temps<128*2)
	{
		RAFRAICHISSEMENT
		GESTION_TEMPS
	}
	
	NEGATIF(100);
	NEGATIF(100);
	ML_clear_vram();
	ML_display_vram();
	Sleep(2000);
	
	
	
	for(i=0;i<NOMBRE_POINTS/4;i+=2)
	{
		points[i]=alea(0,127);
		points[i+1]=alea(0,63);
	}
	
	temps=RTC_getTicks();
	while(RTC_getTicks()-temps<10*128)		//Duree : 10 secondes
	{
		ML_clear_vram();
		for(i=0;i<NOMBRE_POINTS/4;i+=2)ML_pixel(points[i],points[i+1],ML_BLACK);
		
		ML_vertical_line(X-3,Y-1,Y+1,ML_BLACK);
		ML_vertical_line(X+3,Y-1,Y+1,ML_BLACK);
		ML_horizontal_line(Y-3,X-1,X+1,ML_BLACK);
		ML_horizontal_line(Y+3,X-1,X+1,ML_BLACK);
		
		ML_pixel(X-2,Y-2,ML_BLACK);
		ML_pixel(X+2,Y-2,ML_BLACK);
		ML_pixel(X-2,Y+2,ML_BLACK);
		ML_pixel(X+2,Y+2,ML_BLACK);
		
		for(i=0;i<5;i++)
		{
			x=alea(X-5,X+6);
			do
			{
				y=alea(Y-5,Y+6);
			}while(DISTANCE(x,y,X,Y)>8);
			ML_pixel(x,y,ML_BLACK);
		}
		
		pointeur=texte9;
		if(RTC_getTicks()-temps>5*128)pointeur=texte10;	//Le second texte s'affiche au bout de 5 secondes
		
		fenetre(3,VRAI,1,pointeur);
		ML_display_vram();
		Sleep(100);
	}
}