#define LARGEUR 14
#define HAUTEUR 8
#define NOMBRE_SALLES 29

#define HAUT IsKeyDown(KEY_CTRL_UP)
#define DROITE IsKeyDown(KEY_CTRL_RIGHT)
#define BAS IsKeyDown(KEY_CTRL_DOWN)
#define GAUCHE IsKeyDown(KEY_CTRL_LEFT)

#define ALPHA IsKeyDown(KEY_CTRL_ALPHA)
#define SHIFT IsKeyDown(KEY_CTRL_SHIFT)
#define EXIT IsKeyDown(KEY_CTRL_EXIT)
#define MENU IsKeyDown(KEY_CTRL_MENU)
#define EXE IsKeyDown(KEY_CTRL_EXE)

#define MAP(x,y) map->carte[LARGEUR*(y)+(x)]
#define MAP_FUMEE(x,y) map->carte_fumee[LARGEUR*(y)+(x)]
#define DISTANCE(x1,y1,x2,y2) ABS((x1)-(x2))+ABS((y1)-(y2))

#define VITESSE_MAX 8
#define VIE_MAX 100
#define NOMBRE_POUVOIRS 18


#define RAFRAICHISSEMENT ML_clear_vram();\
						 affichage_map(map,general);\
						 affichage_barres_pouvoir(general->pouvoirs_choisis);\
						 ML_display_vram();
						 
#define GESTION_TEMPS setFps(3);

//etat de la partie :
#define NOUVEAU 0
#define CHARGEE 1
#define EN_COURS 2
						 
/******************/
/* Enumerations : */
/******************/
enum Obstacle
{
	RIEN=0,LARME=1,			//Tout élément de valeur inférieure à 10 peut être occupe
	SOURCE_ETHER=10,STATUE_FACE=11,STATUE_DOS=12,TABOURET=13,ARMES=14,COFFRE=15,GRILLE_FACE=16,GRILLE_COTE=17,SOURCE_DIVINE=18,
	MUR1=20,MUR1_EXTREMITE=21,MUR1_FACE=22,PILIER1=23,DOUBLE_PORTE1_GAUCHE=24,DOUBLE_PORTE1_DROITE=25,
	MUR2=30,MUR2_EXTREMITE=31,MUR2_FACE=32,PILIER2=33,FAUSSE_PORTE2_DROITE=34,
	MUR3=40,MUR3_EXTREMITE=41,MUR3_FACE=42,PILIER3=43,
	ETRE=100,PERSONNAGE=101,REMPART=102,LEURRE=103,
	PORTE1_DROITE=200,PORTE1_GAUCHE=201,PORTE1_FACE=202,		//Les éléments de valeur supérieure ou égale à 200 sont des portes
	PORTE2_DROITE=210,PORTE2_GAUCHE=211,PORTE2_FACE=212,
	PORTE3_DROITE=220,PORTE3_GAUCHE=221,PORTE3_FACE=222
};

enum Type
{
	EDASTHEREBE=0,TYPE_LEURRE=1,TYPE_REMPART=2,
	FANATIQUE=3,PIQUIER=4,PRISONNIER=5,PRETRE=6,PRETRESSE=7,
	GRANDE_PRETRESSE=8,HIEROPHANTE=9,PALADIN=10,EX_HIEROPHANTE=11
};

enum Utilisation
{
	INACTIF,UTILISE,RECHARGEMENT
};

enum Bool
{
	VRAI=1,FAUX=0
};

enum Energie
{
	VIBRATILE=0,METAPHYSIQUE=1,TRANSCENDANTE=2,RESIDUELLE=3,CHAOTIQUE=4,PSYCHIQUE=5
};

enum IdPouvoir
{
	AURA_ENTRAVE=0,ECRAN_FUMEE=1,IMPULSION=2,
	FUGACITE=3,VAPORISATION=4,FURTIVITE=5,
	VEHEMENCE=6,BOUCLIER=7,REGENERATION=8,
	DECHARGE_ENERGIE=9,DEFLAGRATION=10,RESSOURCEMENT=11,
	REMPART_ENERGIE=12,CREATION_LEURRE=13,TOURBILLON_CHAOTIQUE=14,
	ETOURDISSEMENT=15,DEMENCE=16,CONFUSION=17
};

enum Mission
{
	TUER_PRETRE=0,
	ALLER_SOURCE_ETHER=1,
	TROUVER_PRETRESSE=2,
	ACCEDER_SOUTERRAIN=3,
	TROUVER_PALADIN=4,
	ATTAQUER_SALLE19=5,
	ATTAQUER_SALLE25=6,
	ALLER_SALLE23=7,
	TROUVER_EX_HIEROPHANTE=8,
	DIVERSION_SALLE4=9,
	AFFRONTEMENT_SALLE5=10,
	ALLER_SALLE14=11,
	ALLER_SALLE5=12,
	ATTAQUER_HIEROPHANTE=13,
	UTILISER_SOURCE=14
};

typedef enum Type Type;
typedef enum Utilisation Utilisation;
typedef enum Obstacle Obstacle;
typedef enum Bool Bool;
typedef enum Energie Energie;
typedef enum IdPouvoir IdPouvoir;
typedef enum Mission Mission;

/****************/
/* Structures : */
/****************/
typedef struct Map Map;
typedef struct Pouvoir Pouvoir;
typedef struct General General;
typedef struct Etre Etre;
typedef struct Liste Liste;
typedef struct Noeud Noeud;
typedef struct Donnees Donnees;

struct Donnees
{
	unsigned int presence_etres[NOMBRE_SALLES];
	Bool presence_larmes[NOMBRE_SALLES];
	Mission mission;
	Bool cinematique_secondaire;
	Bool condition;		//Une variable recyclable, qui peut servir à tout
	Bool visite_magasin;
};

struct Etre
{
	//Caractéristiques :
		Type type;
		short vie_max;
		short attaque_max;
		short vitesse_max;
		short precision_max;
	//
	
	//Etat :
		Bool vivant;
		Bool cache;
		
		Bool deces;
		Bool entrave;
		Bool confus;
	//
	
	//Données de combat :
		char camp;
		short vie;
		short attaque;
		short vitesse;
		char precision;
		short compteur;
		short compteur_frappe;
		char blessure;
	//
	
	//Données physiques :
		char x;
		char y;
		char direction;
		Bool dessous;		//Si une larme sacrée se trouve sous l'être
	//
	
	//Données comportementales :
		char cible_x;
		char cible_y;
		char *cible_blessure;
		short *cible_vie;
		
		//Coordonnées de la case de laquelle doit s'éloigner l'être, s'il n'a pas fait d'autre mouvement
		char repulsion_x;
		char repulsion_y;
		
		char cible_mouvement;
		char cible_attaque;
		Bool acces_cible;
		
		char mode;
		char etourdissement;
		
		char patrouille[20];
		char direction_originelle;
		char cible_patrouille;
	//
};

struct Map
{
	short id;
	Obstacle carte[LARGEUR*HAUTEUR];
	short sortie[4];		//id,x,y,id,x,y...
	Etre etres[60];
	char nombre_etres;
	
	//Gestion de la fumée :
	char carte_fumee[LARGEUR*HAUTEUR];
	char copie_carte_fumee[LARGEUR*HAUTEUR];
	char x_origine;
	char y_origine;
	char compteur;
	char propagation;
	Bool dispersion;
	
	//Sources d'énergie résiduelle :
	char nombre_sources;
	char energie[10];
};

struct Pouvoir
{	
	char inutile;		/*Composante inutilisée, mais nécessaire car le passage de la structure vers la fonction
						  magasin corrompt mystèrieusement la première composante	*/
	
	IdPouvoir id;
	Energie type_energie; 
	char nom[30];
	char x;
	char y;
	
	Bool acquis;
	Bool disponible;
	Pouvoir *preRequis1;
	Pouvoir *preRequis2;
	
	Utilisation etat;
	short temps_utilisation;
	short utilisation;
	short temps_rechargement;
	short rechargement;
	short cout;
};

struct General
{
	short salle;
	Bool zoom;
	Bool alerte;
	char larmes;		//Larmes sacrées, qui servent a payer les pouvoirs
	Bool sortie;		//Si on sort de la salle
	Bool acces_sortie;	//Dans certains cas, la sortie sera bloquée
	
	char direction;		//de 1 à 4
	char regard;	//0=vers l'arrière, 1=vers l'avant
	char x;		//de 0 à 15
	char y;		//de 0 à 7
	
	short vie;
	char blessure;		//si un coup est porte
	
	Pouvoir pouvoirs[NOMBRE_POUVOIRS];
	Pouvoir *pouvoirs_choisis[6];
	
	Bool fugace;
	Bool vapeur;
	Bool furtif;
	Bool alternance;
	Bool vehemence;
	Bool bouclier;
	Bool regeneration;
	
	char etape;		//0=pouvoir non utilisé, 1=recherche de source, 2=en cours
	Etre *cible;	//en cas de décharge d'énergie
	char x_source;
	char y_source;
};

struct Liste
{
	Noeud *premier;
	Noeud *dernier;
	short taille;
};

struct Noeud
{
	char x;
	char y;
	char distance;
	Noeud *parent;
	
	Noeud *suivant;
	Noeud *precedent;
};



/***********/
/* Menu : */
/***********/
void affichage_fond_ecran();


/*********/
/* Jeu : */
/*********/
void test();
int jeu(int fichier,char etat_partie);
void gestion_etres(Map *map,General *general);
short gestion_vitesse(short compteur,short vitesse);
Bool deplacement(Map *map,char deplacement,char *x,char *y,char *direction,Bool dessous,Bool vapeur);
Bool visible(char x1,char y1,char x2,char y2,char direction,Map map);
Obstacle case_devant(char x,char y,char direction,Map *map);
void coordonnees_devant(char x,char y,char direction,char *x2,char *y2);
Bool confine(char x,char y,Map *map);
short evaluer_vitesse(short vitesse,short vie,short vie_max);
void infliger_degats(Etre *etre,short degats);
void ciblage_attaque(Map *map,General *general,Etre *etre);
void ciblage_mouvement(Map *map,General *general,Etre *etre);
Bool special(General *general,Map *map,Donnees *donnees);
void reinitialisation_salle(short *salles,char nombre_salles,Donnees *donnees);

/**************/
/* Pouvoirs : */
/**************/
void utilisation_pouvoir(Map *map,General *general,Pouvoir *pouvoirs_choisis[6]);
void effet_immediat(Map *map,General *general,Pouvoir *pouvoir);
void effet_continu(Map *map,General *general,Pouvoir *pouvoir,char compteur);
void effet_final(Pouvoir *pouvoir,General *general,Map *map);
void gestion_pouvoir(Pouvoir *pouvoir,General *general,Map *map);
char propagation_fumee(Map *map,char x,char y,char propagation,char propagation_max,char etat_case);
char categorie_pouvoir();

/********************/
/* Initialisation : */
/********************/
void initialisation_partie(Donnees *donnees,General *general);
void initialisation_pouvoirs(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6]);
void generation_map(Map *map,short id,Donnees *donnees);
void configuration_etre(Etre *etre,Map *map);



/***************/
/* Affichage : */
/***************/
void affichage_map(Map *map,General *general);
void recapitulatif(Pouvoir *pouvoirs_choisis[6],short vie);

void affichage_element_8(Obstacle obstacle,char x,char y);
void affichage_element_16(Obstacle obstacle,char x,char y);
void affichage_rempart(char x,char y,Bool zoom,Bool degat);
void affichage_carre(char x,char y,ML_Color couleur,Bool zoom);
void affichage_cible(char x,char y);
void affichage_source_ether(char x,char y,Bool zoom);
void affichage_source_divine(char x,char y,Bool zoom);
void affichage_larme(char x,char y,Bool zoom);

void affichage_etre_8(Type type,char x,char y,char direction,char mode,Bool negatif);
void affichage_etre_16(Type type,char x,char y,char direction,char mode,Bool negatif);
void negatif_8(unsigned char *bitmap);
void negatif_16(unsigned short *bitmap);

void affichage_barres_pouvoir(Pouvoir *pouvoirs_choisis[6]);
void repere_8(char x,char y);


/*************/
/* Magasin : */
/*************/
void magasin(Donnees *donnees,Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6],char *larmes);
Pouvoir *deplacement_curseur(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *selection);
Pouvoir *gestion_shift(Pouvoir *selection,Pouvoir *pouvoir_selectionne,char *larmes);
void informations(Pouvoir *selection);
void affichage_magasin(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6],Pouvoir *selection,char *larmes);
void affichage_pouvoir(char x,char y,char id);
void affichage_icone(char x,char y,char numero,Bool negatif);


/*****************/
/* Pathfinding : */
/*****************/
char mouvement_a_effectuer(Map *map,Etre *etre);
Noeud *nouveau_noeud(char x,char y,Noeud *parent);
Noeud *insertion(Noeud *noeud,Liste *liste);
Bool recherche_liste(Noeud *noeud,Liste *liste);
Liste *initialisation();
void suppression_liste(Liste *liste);


/*****************/
/* Données map : */
/*****************/
void map1(Map *map,char donnes_etres[]);
void map2(Map *map,char donnes_etres[]);
void map3(Map *map,char donnees_etres[],Donnees *donnees);
void map4(Map *map,char donnees_etres[],Donnees *donnees);
void map5(Map *map,char donnees_etres[],Donnees *donnees);
void map6(Map *map,char donnees_etres[],Donnees *donnees);
void map7(Map *map,char donnees_etres[],Donnees *donnees);
void map8(Map *map,char donnees_etres[],Donnees *donnees);
void map9(Map *map,char donnees_etres[],Donnees *donnees);
void map10(Map *map,char donnees_etres[],Donnees *donnees);
void map11(Map *map,char donnees_etres[],Donnees *donnees);
void map13(Map *map,char donnees_etres[],Donnees *donnees);
void map14(Map *map,char donnees_etres[],Donnees *donnees);
void map16(Map *map,char donnees_etres[]);
void map17(Map *map,char donnees_etres[]);
void map19(Map *map,char donnees_etres[],Donnees *donnees);
void map20(Map *map,char donnees_etres[],Donnees *donnees);
void map21(Map *map,char donnees_etres[],Donnees *donnees);
void map22(Map *map,char donnees_etres[]);
void map23(Map *map,char donnees_etres[],Donnees *donnees);
void map25(Map *map,char donnees_etres[],Donnees *donnees);
void map26(Map *map,char donnees_etres[],Donnees *donnees);
void map27(Map *map,char donnees_etres[]);
void map28(Map *map,char donnees_etres[]);
void map29(Map *map,char donnees_etres[],Donnees *donnees);

/******************/
/* Cinématiques : */
/******************/
void gestion_cinematiques(Donnees *donnees,Map *map,General *general);
void surpris(char x,char y,Bool zoom);
void fenetre(char taille,Bool depassement,unsigned int key,char texte[200]);

void introduction();
void premiere_visite_magasin();
void pretre_surpris_salle1(Donnees *donnees,Map *map,General *general);
void infiltration_salle2(Map *map,General *general);
void encerclement_salle14(Donnees *donnees,Map *map,General *general);
void encerclement_salle5(Donnees *donnees,Map *map,General *general);
void grande_pretresse_salle9(Map *map,General *general,char mode);
void souterrain_salle11(Map *map,General *general);
void discretion_salle20(Map *map,General *general);
void rencontre_paladin_salle7(Map *map,General *general);
void assaut_salle19(Map *map,General *general);
void bilan_assaut_salle19(Map *map,General *general,Donnees *donnees);
void assaut_salle25(Map *map,General *general);
void bilan_assaut_salle25(Map *map,General *general,Donnees *donnees);
void activation_statue_salle23(Map *map,General *general);
void rencontre_ex_hierophante(Map *map,General *general,Donnees *donnees);
void diversion_salle4(Map *map,General *general,Donnees *donnees);
void affrontement_salle5(Map *map,General *general,Donnees *donnees);
void bilan_salle5(Map *map,General *general,Donnees *donnees);
void rencontre_paladin_salle14(Map *map,General *general);
void preparatifs_salle5(Map *map,General *general);
void assaut_final(Map *map,General *general);
void conclusion(Map *map,General *general,Donnees *donnees);