#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"

void initialisation_partie(Donnees *donnees,General *general)
{
	memset(donnees->presence_etres,0xFFFFFFFF,NOMBRE_SALLES*sizeof(int));
	memset(donnees->presence_larmes,VRAI,NOMBRE_SALLES*sizeof(Bool));
	
	donnees->cinematique_secondaire=FAUX;
	
	general->fugace=FAUX;
	general->vapeur=FAUX;
	general->furtif=FAUX;
	general->vehemence=FAUX;
	general->bouclier=FAUX;
	general->regeneration=FAUX;
	general->regard=1;
	general->alerte=FAUX;
	general->acces_sortie=VRAI;
	general->etape=0;
	donnees->visite_magasin=FAUX;
	
	donnees->mission=TUER_PRETRE;
	general->zoom=VRAI;
	general->salle=1;
	general->x=2;
	general->y=4;
	general->direction=2;
	general->larmes=3;
	general->vie=VIE_MAX;
	
	initialisation_pouvoirs(general->pouvoirs,general->pouvoirs_choisis);
}


void initialisation_pouvoirs(Pouvoir pouvoirs[NOMBRE_POUVOIRS],Pouvoir *pouvoirs_choisis[6])
{
	/*>>>Map hexagonales <<<
		Avec des cercles de rayon 5
		
		
				   (x,y-12)
		(x-10,y-6)			(x+10,y-6)
					[x,y]
		(x-10,y+6)			(x+10,y+6)
				   (x,y+12)
	
	*/
	char coordonnees[NOMBRE_POUVOIRS*2]={7,19,17,25,17,37,27,7,27,19,37,25,57,13,57,25,47,31,77,37,77,49,67,31,57,49,47,55,67,55,27,55,37,49,27,43};
	short temps[NOMBRE_POUVOIRS*2]={	//temps d'utilisation,temps de rechargement
									VITESSE_MAX*40,VITESSE_MAX*40,VITESSE_MAX*12,VITESSE_MAX*18,1,VITESSE_MAX*40,		//énergie vibratile
									VITESSE_MAX*8,VITESSE_MAX*32,VITESSE_MAX*40,VITESSE_MAX*40,VITESSE_MAX*45,VITESSE_MAX*60,		//énergie métaphysique
									VITESSE_MAX*5,VITESSE_MAX*30,VITESSE_MAX*40,100,VITESSE_MAX*15,VITESSE_MAX*60,		//énergie transcendante
									1,VITESSE_MAX*30,1,VITESSE_MAX*15,1,VITESSE_MAX*60,		//énergie résiduelle
									1,VITESSE_MAX*60,1,VITESSE_MAX*60,1,VITESSE_MAX*35,		//énergie chaotique
									1,VITESSE_MAX*40,1,VITESSE_MAX*100,VITESSE_MAX*50,VITESSE_MAX*50};		//énergie psychique								
									
	
	char i;
	Pouvoir *pouvoir;
	
	for(i=0;i<NOMBRE_POUVOIRS;i++)
	{
		pouvoir=&pouvoirs[i];
			
		pouvoir->etat=INACTIF;
		pouvoir->acquis=FAUX;
		pouvoir->id=i;
		
		pouvoir->x=coordonnees[i*2];
		pouvoir->y=coordonnees[i*2+1];
		
		pouvoir->temps_utilisation=temps[i*2];
		pouvoir->temps_rechargement=temps[i*2+1];
		pouvoir->utilisation=temps[i*2];
		pouvoir->rechargement=0;
		
		
		pouvoir->preRequis1=NULL;
		pouvoir->preRequis2=NULL;
		
		pouvoir->type_energie=pouvoir->id/3;
				
		switch(i)
		{
			case 0:
				strcpy(pouvoir->nom,"Aura d'entrave");
			Bcase(1)
				strcpy(pouvoir->nom,"Ecran de fumee");
				pouvoir->preRequis1=&pouvoirs[AURA_ENTRAVE];
				pouvoir->preRequis2=&pouvoirs[VAPORISATION];
			Bcase(2)
				strcpy(pouvoir->nom,"Impulsion");
				pouvoir->preRequis1=&pouvoirs[ECRAN_FUMEE];
			Bcase(3)
				strcpy(pouvoir->nom,"Fugacite");
			Bcase(4)
				strcpy(pouvoir->nom,"Vaporisation");
				pouvoir->preRequis1=&pouvoirs[FUGACITE];
			Bcase(5)
				strcpy(pouvoir->nom,"Furtivite");
				pouvoir->preRequis1=&pouvoirs[VAPORISATION];
			Bcase(6)
				strcpy(pouvoir->nom,"Vehemence");
			Bcase(7)
				strcpy(pouvoir->nom,"Bouclier");
				pouvoir->preRequis1=&pouvoirs[VEHEMENCE];
			Bcase(8)
				strcpy(pouvoir->nom,"Regeneration");
				pouvoir->preRequis1=&pouvoirs[BOUCLIER];
				pouvoir->preRequis2=&pouvoirs[FURTIVITE];
			Bcase(9)
				strcpy(pouvoir->nom,"Decharge d'energie");
			Bcase(10)
				strcpy(pouvoir->nom,"Deflagration");
				pouvoir->preRequis1=&pouvoirs[DECHARGE_ENERGIE];
			Bcase(11)
				strcpy(pouvoir->nom,"Ressourcement");
				pouvoir->preRequis1=&pouvoirs[DECHARGE_ENERGIE];
				pouvoir->preRequis2=&pouvoirs[BOUCLIER];
			Bcase(12)
				strcpy(pouvoir->nom,"Rempart d'energie");
			Bcase(13)
				strcpy(pouvoir->nom,"Leurre");
				pouvoir->preRequis1=&pouvoirs[REMPART_ENERGIE];
				pouvoir->preRequis2=&pouvoirs[DEMENCE];
			Bcase(14)
				strcpy(pouvoir->nom,"Tourbillon chaotique");
				pouvoir->preRequis1=&pouvoirs[REMPART_ENERGIE];
				pouvoir->preRequis2=&pouvoirs[DEFLAGRATION];
			Bcase(15)
				strcpy(pouvoir->nom,"Etourdissement");
			Bcase(16)
				strcpy(pouvoir->nom,"Demence");
				pouvoir->preRequis1=&pouvoirs[ETOURDISSEMENT];
			Bcase(17)
				strcpy(pouvoir->nom,"Confusion");
				pouvoir->preRequis1=&pouvoirs[DEMENCE];
				pouvoir->preRequis2=&pouvoirs[IMPULSION];
			break;
		}
		
		pouvoir->cout=2*(pouvoir->id%3)+(pouvoir->preRequis2==NULL);
	}
	
	
	for(i=0;i<6;i++)pouvoirs_choisis[i]=NULL;
}

void generation_map(Map *map,short id,Donnees *donnees)
{
	char *etres,donnees_etres[500];
	short i,j=0,k,x,y;
	map->id=id;
	map->dispersion=FAUX;

	switch(id)
	{
		case 1: map1(map,donnees_etres);
		Bcase(2)map2(map,donnees_etres);
		Bcase(3)map3(map,donnees_etres,donnees);
		Bcase(4)map4(map,donnees_etres,donnees);
		Bcase(5)map5(map,donnees_etres,donnees);
		Bcase(6)map6(map,donnees_etres,donnees);
		Bcase(7)map7(map,donnees_etres,donnees);
		Bcase(8)map8(map,donnees_etres,donnees);
		Bcase(9)map9(map,donnees_etres,donnees);
		Bcase(10)map10(map,donnees_etres,donnees);
		Bcase(11)map11(map,donnees_etres,donnees);
		Bcase(13)map13(map,donnees_etres,donnees);
		Bcase(14)map14(map,donnees_etres,donnees);
		Bcase(15)map15(map,donnees_etres);
		Bcase(16)map16(map,donnees_etres);
		Bcase(17)map17(map,donnees_etres);
		Bcase(19)map19(map,donnees_etres,donnees);
		Bcase(20)map20(map,donnees_etres,donnees);
		Bcase(21)map21(map,donnees_etres,donnees);
		Bcase(22)map22(map,donnees_etres);
		Bcase(23)map23(map,donnees_etres,donnees);
		Bcase(25)map25(map,donnees_etres,donnees);
		Bcase(26)map26(map,donnees_etres,donnees);
		Bcase(27)map27(map,donnees_etres);
		Bcase(28)map28(map,donnees_etres);
		Bcase(29)map29(map,donnees_etres,donnees);
		break;
	}
	
	//Gestion de la présence des larmes :
	for(i=0;i<LARGEUR;i++)for(j=0;j<HAUTEUR;j++)if(MAP(i,j)==LARME && !donnees->presence_larmes[id-1])MAP(i,j)=RIEN;
	
	for(i=0;i<LARGEUR*HAUTEUR;i++)map->carte_fumee[i]=0;
	for(i=0;i<LARGEUR*HAUTEUR;i++)map->copie_carte_fumee[i]=0;
	
	//Génération des sources d'énergie :
	map->nombre_sources=alea(3,5);
	memset(map->energie,-1,10*sizeof(char));
	for(i=0;i<map->nombre_sources;i++)
	{
		do
		{
			x=alea(0,LARGEUR-1);
			y=alea(0,HAUTEUR-1);
			
			k=0;
			for(j=0;j<map->nombre_sources;j++)k+=(map->energie[j*2]==x && map->energie[2*j+1]==y);
		}while(k);
		
		map->energie[2*i]=x;
		map->energie[2*i+1]=y;
	}
	
	//Initialisation des êtres :
	memset(map->etres,0,40*sizeof(Etre));
	j=0;
	for(i=0;donnees_etres[i]!=100;i++)j+=(donnees_etres[i]==99);
	map->nombre_etres=j+3;
	for(i=3;i<map->nombre_etres;i++)memset(map->etres[i].patrouille,0,sizeof(char));
	
	k=2;
	j=-1;
	i=-1;
	
	do
	{	
		i++;
		switch(j)
		{
			case 0: map->etres[k].type=donnees_etres[i];
			Bcase(1)map->etres[k].direction_originelle=donnees_etres[i];
			Bcase(2) map->etres[k].camp=donnees_etres[i];
			break;
		}
		
		if(j>=3 && donnees_etres[i]<99)(map->etres[k]).patrouille[j-3]=donnees_etres[i];
		j++;
		
		if(donnees_etres[i]>=99)
		{				
			if(k>=3)
			{
				configuration_etre(&map->etres[k],map);
				map->etres[k].vivant=donnees->presence_etres[id-1]&(1<<(k-3));
			}
			
			j=0;
			k++;
			if(k<map->nombre_etres)memset(map->etres[k].patrouille,0,20*sizeof(char));
		}
		
	}while(donnees_etres[i]!=100);
	
	map->etres[0].type=EDASTHEREBE;
	map->etres[0].vivant=VRAI;
	map->etres[0].camp=0;
	
	map->etres[1].type=TYPE_LEURRE;
	map->etres[1].vivant=VRAI;
	map->etres[1].x=-1;
	map->etres[1].camp=0;
	map->etres[1].vie=10;
	map->etres[1].blessure=0;
	
	map->etres[2].type=TYPE_REMPART;
	map->etres[2].vivant=VRAI;
	map->etres[2].x=-1;
	map->etres[2].camp=0;
	map->etres[2].vie=200;
	map->etres[2].blessure=0;
}


void configuration_etre(Etre *etre,Map *map)
{
	//Dans l'ordre : vie,attaque,vitesse,précision
	short caracteristiques[9][4]={{120,15,24,60},		//Fanatique
								  {100,12,16,75},		//Piquier
								  {100,10,12,90},			//Prisonnier
								  {80,12,14,80},		//Prêtre
								  {70,12,12,90},			//Prêtresse
								  {300,14,16,90},		//Grande prêtresse
								  {300,20,16,80},			//Hiérophante
								  {500,15,20,80},		//Paladin
								  {250,16,18,90}};		//Ex-hiérophante
	
	//Caractéristiques moyennes : vie=100 attaque=10 vitesse=16 précision=80%
	//Plus la valeur de la variable vitesse est élevée, plus l'être est lent (1 mouvement toutes les vitesse itérations)
	
	etre->mode=0;
	etre->dessous=FAUX;
	etre->vivant=VRAI;
	etre->cache=FAUX;
	etre->deces=FAUX;
	
	etre->x=etre->patrouille[0];
	etre->y=etre->patrouille[1];
	etre->mode=0;
	etre->etourdissement=0;
	etre->direction=etre->direction_originelle;
	MAP(etre->x,etre->y)=ETRE;
	
	etre->cible_mouvement=-1;
	etre->cible_attaque=-1;
	etre->acces_cible=VRAI;
	etre->cible_x=0;
	etre->cible_y=0;
	etre->cible_patrouille=0;
	
	etre->repulsion_x=-1;
	
	etre->entrave=FAUX;
	etre->confus=FAUX;
	
	etre->vie_max=caracteristiques[etre->type-3][0];
	etre->attaque_max=caracteristiques[etre->type-3][1];
	etre->vitesse_max=caracteristiques[etre->type-3][2];
	etre->precision_max=caracteristiques[etre->type-3][3];
	
	etre->vie=etre->vie_max;
	etre->attaque=etre->attaque_max;
	etre->vitesse=etre->vitesse_max;
	etre->precision=etre->precision_max;
	
	etre->compteur=etre->vitesse;
	etre->compteur_frappe=0;
	etre->blessure=0;
}