#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"

int jeu(int fichier,char etat_partie)
{
	General *general=malloc(sizeof(General));
	Map *map=malloc(sizeof(Map));
	Donnees *donnees=malloc(sizeof(Donnees));
	short vitesse=VITESSE_MAX,compteur=VITESSE_MAX;
	Obstacle obstacle;
	char i,mouvement;
	FONTCHARACTER nom_fichier[20]={'\\','\\','f','l','s','0','\\','E','T','H','E','R','.','s','a','v',0};
	
	general->vie=1;

	do
	{
		if(etat_partie==NOUVEAU)initialisation_partie(donnees,general);
		else
		{
			Bfile_ReadFile(fichier,general,sizeof(General),0);
			Bfile_ReadFile(fichier,map,sizeof(Map),sizeof(General));
			Bfile_ReadFile(fichier,donnees,sizeof(Donnees),sizeof(General)+sizeof(Map));
		}

		do
		{
			if(etat_partie!=CHARGEE)
			{
				generation_map(map,general->salle,donnees);
				general->alerte=FAUX;
			}
			
			general->alternance=VRAI;
			general->sortie=FAUX;
			gestion_cinematiques(donnees,map,general);		//Envoie une cinématique, s'il y a lieu
			
			general->blessure=0;		//De manière générale, les variables "blessure" servent à gérer la durée d'affichage des animations de blessure
			while(general->vie>0 && !general->sortie)
			{
				etat_partie=EN_COURS;
				if(general->blessure)general->blessure--;
			
				vitesse=evaluer_vitesse(VITESSE_MAX,general->vie,VIE_MAX);
				vitesse+=(vitesse/2)*general->furtif-vitesse*general->vehemence;
				compteur=gestion_vitesse(compteur,vitesse);
							
				if(!compteur)
				{
					obstacle=RIEN;
					if(!general->vapeur)MAP(general->x,general->y)=RIEN;
					
					mouvement=0;
					if(HAUT)mouvement=1;
					if(DROITE)mouvement=2;
					if(BAS)mouvement=3;
					if(GAUCHE)mouvement=4;
					if(mouvement>4)mouvement=0;
					
					if(deplacement(map,mouvement,&(general->x),&(general->y),&(general->direction),FAUX,general->vapeur))
					{
						if(mouvement==1)general->regard=0;
						if(mouvement==3)general->regard=1;
						
						if(general->regeneration)general->pouvoirs_choisis[2]->utilisation=0;
						if(general->etape==1)general->etape=0;
					}
					else if(mouvement)
					{
						obstacle=case_devant(general->x,general->y,general->direction,map);
						if(obstacle>=200 && general->acces_sortie)general->sortie=VRAI;
					}
					
					
					if(!general->vapeur)
					{
						//Si on est sur une larme sacrée, on l'empoche :
						if(MAP(general->x,general->y)==LARME)
						{
							general->larmes+=6;
							donnees->presence_larmes[general->salle-1]=FAUX;
						}
						MAP(general->x,general->y)=PERSONNAGE;	
					}
				}else obstacle=case_devant(general->x,general->y,general->direction,map);
				
				if(!general->sortie)gestion_etres(map,general);
				
				//Gestion des pouvoirs :
				if(map->dispersion)dispersion_fumee(map);
				utilisation_pouvoir(map,general,general->pouvoirs_choisis);
				for(i=0;i<6;i++)effet_continu(map,general,general->pouvoirs_choisis[i],compteur);
				for(i=0;i<6;i++)gestion_pouvoir(general->pouvoirs_choisis[i],general,map);
				
				//Gestion des sources d'éther (soin et accès au magasin)
				if(obstacle==SOURCE_ETHER && !general->alerte)
				{
					general->vie++;
					if(general->vie > VIE_MAX)general->vie=VIE_MAX;
					if(ALPHA)magasin(donnees,general->pouvoirs,general->pouvoirs_choisis,&(general->larmes));
				}
				
				//Gestion du zoom :
				if(SHIFT && !general->etape)
				{
					general->zoom=!general->zoom;
					while(SHIFT)Sleep(100);
				}
				
				RAFRAICHISSEMENT
				recapitulatif(general->pouvoirs_choisis,general->vie);
				
				//La sous-variable "étape" sert à gérer la sélection des sources d'énergie
				if(general->etape>2)
				{
					general->etape--;
					if(general->etape==2)general->etape=0;
				}
				
				//Gestion des sauvegardes
				if(MENU)
				{
					PopUpWin(2);
					PrintMini(11,13,CUC "Voulez-vous vraiment",1);
					PrintMini(11,19,CUC "quitter ?",1);
					PrintMini(11,29,CUC "F1 : oui",1);
					PrintMini(84,29,CUC "F6 : non",1);
					ML_display_vram();
					while(IsKeyUp(KEY_CTRL_F1) && IsKeyUp(KEY_CTRL_F6))Sleep(100);
					
					if(IsKeyDown(KEY_CTRL_F1))
					{
						char *buffer=malloc(sizeof(General)+sizeof(Map)+sizeof(Donnees));
						
						if(fichier)Bfile_CloseFile(fichier);
						Bfile_DeleteFile(nom_fichier);
						
						Bfile_CreateFile(nom_fichier,sizeof(General)+sizeof(Map)+sizeof(Donnees));
						fichier=Bfile_OpenFile(nom_fichier,_OPENMODE_WRITE);
						
						memcpy(buffer,general,sizeof(General));
						memcpy(buffer+sizeof(General),map,sizeof(Map));
						memcpy(buffer+sizeof(General)+sizeof(Map),donnees,sizeof(Donnees));
						Bfile_WriteFile(fichier,buffer,sizeof(General)+sizeof(Map)+sizeof(Donnees));
						free(buffer);
						
						free(general);
						free(map);
						free(donnees);
						while(IsKeyDown(KEY_CTRL_F1))Sleep(100);
						return fichier;
					}
					
					while(IsKeyDown(KEY_CTRL_F6))Sleep(100);
				}
				
				//Gestion de la fin de la partie :
				if(special(general,map,donnees))
				{
					if(fichier)
					{
						Bfile_CloseFile(fichier);
						Bfile_DeleteFile(nom_fichier);
					}
					
					free(general);
					free(map);
					free(donnees);
					return 0;
				}
				
				GESTION_TEMPS
			}
			
			//Gestion de la sortie de la salle
			if(general->sortie)
			{
				Pouvoir *pouvoir;
				
				//Si des êtres sont morts, on met à jour le tableau :
				for(i=3;i<map->nombre_etres;i++)donnees->presence_etres[general->salle-1]&=~((!map->etres[i].vivant)<<(i-3));
				general->salle=map->sortie[general->direction-1];
				
				
				pouvoir=general->pouvoirs_choisis[VIBRATILE];
				if(pouvoir)
				{
					if(pouvoir->id==ECRAN_FUMEE && pouvoir->etat==UTILISE)
					{
						pouvoir->utilisation=pouvoir->temps_utilisation;
						pouvoir->etat=RECHARGEMENT;
						map->dispersion=FAUX;
						map->propagation=0;
					}
				}
				
				switch(general->direction)
				{
					case 1: general->y=HAUTEUR-2;
					Bcase(2) general->x=1;
					Bcase(3) general->y=1;
					Bcase(4) general->x=LARGEUR-2;
				}
			}
		}while(general->vie>0);
		
		//Gestion de la défaite :
		PopUpWin(2);
		PrintMini(34,13,CUC "VOUS ETES MORT !",1);
		if(fichier)
		{
			PrintMini(11,19,CUC "Reprise a la derniere",1);
			PrintMini(11,25,CUC "sauvegarde",1);
		}
		else
		{
			PrintMini(11,19,CUC "Vous auriez du penser",1);
			PrintMini(11,25,CUC "a faire une sauvegarde...",1);
		}
		ML_display_vram();
		
		while(IsKeyUp(KEY_CTRL_EXE))Sleep(100);
		while(IsKeyDown(KEY_CTRL_EXE))Sleep(100);
		etat_partie=CHARGEE;
		
	}while(fichier);
	
	free(general);
	free(map);
	free(donnees);
	return 0;
}

void gestion_etres(Map *map,General *general)
{
	char i,j,k,degats,x2,y2,mouvement,obstacle;
	Bool alerte=FAUX;
	Etre *etre,*etre2;
			
	for(i=0;i<map->nombre_etres;i++)
	{
		etre=&(map->etres[i]);
		//Dans cette fonction, on ne s'occupe pas d'Edasthérèbe, du leurre ou du rempart :
		if(i<=2)
		{
			if(!i)
			{	
				etre->x=general->x;
				etre->y=general->y;
				etre->vie=general->vie;
				etre->blessure=general->blessure;
			}
			else
			{
				if(etre->blessure)etre->blessure--;
				if(etre->vie<=0)
				{
					if(etre->dessous)MAP(etre->x,etre->y)=LARME;
					else MAP(etre->x,etre->y)=RIEN;
					
					etre->x=-1;
					etre->vie=100<<(etre->type==TYPE_REMPART);
				}
			}
		}
		else
		{
			//Si l'être est tué, on met à jour :
			if(etre->deces && !etre->blessure)
			{
				etre->deces=FAUX;
				etre->vivant=FAUX;
				if(etre->dessous)MAP(etre->x,etre->y)=LARME;
				else MAP(etre->x,etre->y)=RIEN;
			}
			if(etre->blessure)etre->blessure--;
			
			if(etre->vivant)
			{
				etre->attaque=etre->attaque_max;
				etre->vitesse=evaluer_vitesse(etre->vitesse_max,etre->vie,etre->vie_max);
				etre->precision=etre->precision_max;
				
				etre->cible_x=-1;
				
				if(etre->entrave)etre->precision/=2;
				
				etre->compteur=gestion_vitesse(etre->compteur,etre->vitesse);
				if(!etre->compteur)etre->mode=0;
				mouvement=0;
				
				if(!etre->etourdissement)
				{
					if(general->alerte)
					{
						etre->mode=1;
						if(!etre->compteur)
						{
							ciblage_attaque(map,general,etre);
							
							//-1 est la valeur qui correspond à l'absnce de cible :
							if(etre->cible_attaque!=-1)
							{
								//Si la cible est à côté, on se tourne vers elle :
								if(DISTANCE(etre->x,etre->y,etre->cible_x,etre->cible_y)==1)
								{
									if(etre->x==etre->cible_x && etre->y-1==etre->cible_y)etre->direction=1;
									if(etre->x+1==etre->cible_x && etre->y==etre->cible_y)etre->direction=2;
									if(etre->x==etre->cible_x && etre->y+1==etre->cible_y)etre->direction=3;
									if(etre->x-1==etre->cible_x && etre->y==etre->cible_y)etre->direction=4;
								}				
								
								if(etre->compteur_frappe)etre->compteur_frappe++;
								if(etre->compteur_frappe==5)etre->compteur_frappe=0;
								
								coordonnees_devant(etre->x,etre->y,etre->direction,&x2,&y2);
								
								if(x2==etre->cible_x && y2==etre->cible_y && !*etre->cible_blessure && !etre->compteur_frappe)
								{
									k=0;
									//S'il y a un allié dans la case ciblée, on n'attaque pas :
									for(j=0;j<map->nombre_etres;j++)
									{
										etre2=&(map->etres[j]);
										k+=(etre2->camp==etre->camp && etre2->x==x2 && etre2->y==y2);
									}
									
									//Gestion de l'attaque :
									if(alea(1,100)<=etre->precision && !k)
									{
										*etre->cible_blessure=8;
										degats=(etre->attaque*alea(80,120))/100;
										
										if(general->bouclier && !etre->cible_attaque)
										{
											infliger_degats(&map->etres[etre->cible_attaque],degats/2);
											infliger_degats(etre,degats/2);
										}
										else infliger_degats(&map->etres[etre->cible_attaque],degats);
									}
									if(!k)etre->compteur_frappe++;
								}
							}
							
							//Gestion de la recherche de cible :
							ciblage_mouvement(map,general,etre);
							if(!MAP_FUMEE(etre->x,etre->y) && etre->cible_mouvement!=-1)
							{
								if(DISTANCE(etre->x,etre->y,etre->cible_x,etre->cible_y)>1)
								{
									mouvement=mouvement_a_effectuer(map,etre);
									if(!mouvement)etre->acces_cible=FAUX;
								}
							}
						}
					}
					else
					{
						etre->cible_x=etre->patrouille[etre->cible_patrouille];
						etre->cible_y=etre->patrouille[etre->cible_patrouille+1];
						if(!etre->compteur)mouvement=mouvement_a_effectuer(map,etre);
					}
					
					//Si on est sur la même case qu'Edasthérèbe, on bouge :
					if(general->x==etre->x && general->y==etre->y && !etre->compteur)
					{
						mouvement=0;
						for(j=1;j<=4 && !mouvement;j++)if(case_devant(etre->x,etre->y,j,map)<10)mouvement=j;
					}
					
					//Si on est sur la case à fuir (répulsion), on s'en éloigne. On s'en éloigne également si on a pas fait d'autre mouvement :
					if(etre->repulsion_x!=-1 && !etre->compteur && ((!mouvement && etre->cible_attaque==-1) || (etre->x==etre->repulsion_x && etre->y==etre->repulsion_y)))
					{
						for(j=1;j<=4 && !mouvement;j++)
							if(case_devant(etre->x,etre->y,j,map)<10 && 
							   ABS(etre->x+(mouvement==2)-(mouvement==4)-etre->repulsion_x) >= ABS(etre->x-etre->repulsion_x) &&
							   ABS(etre->y+(mouvement==3)-(mouvement==1)-etre->repulsion_y) >= ABS(etre->y-etre->repulsion_y))
							mouvement=j;
					}
					
					if(etre->confus && !alea(0,4) && !etre->compteur)
					{
						//Si l'être est confus, ses déplacements deviennent aléatoires
						do
						{
							j=alea(1,4);
						}while(j==mouvement);
						
						mouvement=j;
					}
					
					//Gestion du déplacement :
					if(mouvement && !MAP_FUMEE(etre->x,etre->y))
					{	
						MAP(etre->x,etre->y)=RIEN;
						deplacement(map,mouvement,&etre->x,&etre->y,&etre->direction,etre->dessous,FAUX);
						
						if(MAP(etre->x,etre->y)==LARME)etre->dessous=VRAI;
						else etre->dessous=FAUX;
						MAP(etre->x,etre->y)=ETRE;
						
						etre->mode=1;
					}
					
					
					if(!etre->compteur && MAP_FUMEE(etre->x,etre->y) && case_devant(etre->x,etre->y,etre->direction,map)!=PERSONNAGE)etre->direction+=2-4*(etre->direction>2);		//L'être tourne en rond s'il est perdu dans la fumée
					
					if(etre->patrouille[etre->cible_patrouille])
					{
						if(etre->x==etre->cible_x && etre->y==etre->cible_y)etre->cible_patrouille+=2;
						if(!etre->patrouille[etre->cible_patrouille])
						{
							if(!mouvement && !etre->compteur)etre->direction=etre->direction_originelle;
							etre->cible_patrouille=0;
						}
					}
					
					//Si on voit de la fumée ou un ennemi, on lance l'alerte :
					coordonnees_devant(etre->x,etre->y,etre->direction,&x2,&y2);
					if(!general->alerte)
					{
						k=0;
						for(j=map->nombre_etres-1;j>=0;j--)
						{
							etre2=&map->etres[j];
							if(etre->camp!=etre2->camp)if(visible(etre->x,etre->y,etre2->x,etre2->y,etre->direction,*map) && etre->vivant
								&& (j || (!j && !general->fugace && (!general->furtif || DISTANCE(etre2->x,etre2->y,etre->x,etre->y)>1))))k++;
						}
						
						
						if(k || MAP_FUMEE(etre->x,etre->y) || MAP_FUMEE(x2,y2) || (general->x==etre->x && general->y==etre->y))
						{
							alerte=VRAI;
							etre->mode=1;
							if(general->furtif)general->pouvoirs_choisis[METAPHYSIQUE]->utilisation=1;
						}
					}

					etre->entrave=FAUX;
					if(alerte==VRAI)general->alerte=VRAI;
				}
				else
				{
					etre->etourdissement--;
					etre->mode=1;
				}
				
				if(etre->type==GRANDE_PRETRESSE || etre->type==HIEROPHANTE)etre->mode=0;
			}
			else if(etre->cache && MAP(etre->x,etre->y)<10)
			{
				etre->vivant=VRAI;
				etre->cache=FAUX;
				
				if(MAP(etre->x,etre->y)==LARME)etre->dessous=VRAI;
				MAP(etre->x,etre->y)=ETRE;
			}
		}
	}
	
	etre=&map->etres[0];
	general->x=etre->x;
	general->y=etre->y;
	general->vie=etre->vie;
	general->blessure=etre->blessure;
}


Bool visible(char x1,char y1,char x2,char y2,char direction,Map map)
{
	char x=x1*8+4,y=y1*8+4,x_cible=x2*8+4,y_cible=y2*8+4,distance_x,distance_y,var_x=0,var_y=0,erreur,i;
	Obstacle carre;
	
	distance_x=ABS(x-x_cible);
	distance_y=ABS(y-y_cible);

	if(x<x_cible)var_x=1;
	else if(x>x_cible) var_x=-1;
	if(y<y_cible)var_y=1;
	else if(y>y_cible)var_y=-1;
	
	if((direction==1 && var_y==1) || (direction==2 && var_x==-1) || (direction==3 && var_y==-1) || (direction==4 && var_x==1))
		return FAUX;				//Les ennemis ne sont pas capables de voir derrière eux !

	//Algorithme de Bresenham :
	if(distance_x>distance_y)
	{
		erreur=distance_x/2;
		for(i=0;i<distance_x;i++)
		{
			x+=var_x;
			erreur+=distance_y;
			if(erreur>distance_x)
			{
				erreur-=distance_x;
				y+=var_y;
			}
			
			carre=map.carte[LARGEUR*(y/8)+(x/8)];
			if(carre>=10 && (x/8!=x2 || y/8!=y2) && (x/8!=x1 || y/8!=y1))return FAUX;
		}
	}
	else
	{
		erreur=distance_y/2;
		for(i=0;i<distance_y;i++)
		{
			y+=var_y;
			erreur+=distance_x;
			if(erreur>distance_y)
			{
				erreur-=distance_y;
				x+=var_x;
			}
			
			carre=map.carte[LARGEUR*(y/8)+(x/8)];
			if(carre>=10 && (x/8!=x2 || y/8!=y2) && (x/8!=x1 || y/8!=y1))return FAUX;
		}
	}
	
	return VRAI;
}

Bool deplacement(Map *map,char mouvement,char *x,char *y,char *direction,Bool dessous,Bool vapeur)
{
	char x2=*x,y2=*y;
	
	if(mouvement)*direction=mouvement;
	x2+=(mouvement==2)-(mouvement==4);
	y2+=(mouvement==3)-(mouvement==1);
	
	if(mouvement && (MAP(x2,y2)<10 || (MAP(x2,y2)==ETRE && vapeur)))
	{
		if(dessous)MAP(*x,*y)=LARME;
		*x=x2;
		*y=y2;
		return VRAI;
	}
	
	return FAUX;
}

Bool confine(char x,char y,Map *map)
{
	return (MAP(x,y+1)>=10 && MAP(x,y+1)!=REMPART
			&& MAP(x+1,y)>=10 && MAP(x+1,y)!=REMPART
			&& MAP(x-1,y)>=10 && MAP(x-1,y)!=REMPART
			&& MAP(x,y-1)>=10 && MAP(x,y-1)!=REMPART);
}

short gestion_vitesse(short compteur,short vitesse)
{
	compteur++;
	return compteur*(compteur<vitesse);
}

Obstacle case_devant(char x,char y,char direction,Map *map)
{
	return MAP(x-(direction==4)+(direction==2),y-(direction==1)+(direction==3));
}

void coordonnees_devant(char x,char y,char direction,char *x2,char *y2)
{
	*x2=x-(direction==4)+(direction==2);
	*y2=y-(direction==1)+(direction==3);
}


short evaluer_vitesse(short vitesse,short vie,short vie_max)
{
	return ((vitesse*(1000+((((vie_max-vie)*1000)/vie_max)/2)))/1000);
}

void infliger_degats(Etre *etre,short degats)
{
	etre->vie-=degats;
	if(etre->vie<=0 && etre->type>=FANATIQUE)etre->deces=VRAI;
	etre->blessure=8;
}

void ciblage_attaque(Map *map,General *general,Etre *etre)
{
	char i;
	Etre *cible;
	etre->cible_attaque=-1;
	
	for(i=map->nombre_etres-1;i>=0;i--)
	{
		cible=&map->etres[i];
		if(DISTANCE(etre->x,etre->y,cible->x,cible->y)<=1 && cible->x!=-1 && cible->camp!=etre->camp && cible->vivant)
		{
			etre->cible_attaque=i;
			etre->cible_x=cible->x;
			etre->cible_y=cible->y;
			etre->cible_blessure=&cible->blessure;
			etre->cible_vie=&cible->vie;
		}
	}
}

void ciblage_mouvement(Map *map,General *general,Etre *etre)
{
	char i=0,cible_choisie=-1,distance,distance_max=100,exclu=-1;
	Etre *cible;
	
	if(etre->cible_mouvement!=-1)i=!map->etres[etre->cible_mouvement].vivant;	//Si on a une cible, on regarde si elle est morte
	
	if(etre->cible_mouvement!=-1 && (!etre->acces_cible || i))		//Si la cible est morte, ou si on n'a pas réussi à s'en approcher
	{
		exclu=etre->cible_mouvement;	//On l'exclut de la liste
		etre->cible_mouvement=-1;		//On considère qu'on a plus de cible
	}
	
	for(i=map->nombre_etres-1;i>=0;i-=1+(i==3))
	{
		cible=&map->etres[i];
		distance=DISTANCE(etre->x,etre->y,cible->x,cible->y);
		if(((etre->cible_mouvement==-1 && distance<=distance_max) || etre->cible_mouvement==i) && etre->camp!=cible->camp && cible->x!=-1 && exclu!=i && (cible->vivant || i<2))
		{
			/*Critères de sélection d'une cible :
			  -Elle est la plus proche, OU elle correspond déjà à la cible actuelle
			  -Elle n'est pas dans le même camp
			  -Son abscisse ne vaut pas moins -1 (concerne le leurre)
			  -Elle n'est pas exclue de la liste
			  -Elle est vivante, à moins qu'il s'agisse d'Edasthérèbe ou du leurre (cas spécifique)
			*/
			
			distance_max=distance;
			cible_choisie=i;
			etre->cible_x=cible->x;
			etre->cible_y=cible->y;
		}
	}
	
	if(etre->cible_mouvement==-1)etre->cible_mouvement=cible_choisie;
	etre->acces_cible=VRAI;
}

Bool special(General *general,Map *map,Donnees *donnees)
{
	//Evenements ou modifications specifiques a certaines salles,selon les missions
	char i,j;
	static short nombre_frames=330;
	Etre *etre;
	
	switch(donnees->mission)
	{
		case ATTAQUER_SALLE19:
			if(general->salle==19)
			{
				if(donnees->condition)
				{
					j=0;
					for(i=8;i<map->nombre_etres;i++)j+=(map->etres[i].cache==VRAI);
					
					if(!j)
					{
						for(i=8;i<map->nombre_etres;i++)map->etres[i].repulsion_x=-1;
						donnees->condition=FAUX;
					}
				}
				
				j=0;
				for(i=3;i<8;i++)j+=(map->etres[i].vivant==VRAI || map->etres[i].blessure==VRAI);
				if(!j)
				{
					short salles[]={19,25,20};
					reinitialisation_salle(salles,2,donnees);
					
					Sleep(1000);
					donnees->mission++;
					general->acces_sortie=VRAI;
					general->alerte=FAUX;
					bilan_assaut_salle19(map,general,donnees);
				}
			}
		Bcase(ATTAQUER_SALLE25)
			if(general->salle==25)
			{
				if(donnees->condition)
				{
					j=0;
					for(i=21;i<map->nombre_etres;i++)j+=(map->etres[i].cache==VRAI);
					
					if(!j)
					{
						for(i=21;i<map->nombre_etres;i++)map->etres[i].repulsion_x=-1;
						donnees->condition=FAUX;
					}
				}
				
				j=0;
				for(i=3;i<20;i++)j+=(map->etres[i].vivant==VRAI || map->etres[i].blessure==VRAI);
				if(!j)
				{
					short salles[]={25,20,26};
					reinitialisation_salle(salles,3,donnees);
					
					Sleep(1000);
					donnees->mission++;
					general->acces_sortie=VRAI;
					general->alerte=FAUX;
					bilan_assaut_salle25(map,general,donnees);
				}
			}
		Bcase(DIVERSION_SALLE4)
			if(general->salle==4)
			{
				nombre_frames--;
				if(!nombre_frames)
				{
					donnees->mission++;
					general->acces_sortie=VRAI;
					affrontement_salle5(map,general,donnees);
				}
			}
		Bcase(ATTAQUER_HIEROPHANTE)
			if(general->salle==6 && !map->etres[20].vivant)
			{
				donnees->mission++;
				conclusion(map,general,donnees);
				return VRAI;
			}
		break;
	}
	
	return FAUX;
}

void reinitialisation_salle(short *salles,char nombre_salles,Donnees *donnees)
{
	char i;
	for(i=0;i<nombre_salles;i++)donnees->presence_etres[salles[i]-1]=0xFFFFFFFF;
}