#include <stdio.h>
#include <stdlib.h>
#include "fxlib.h"
#include "MonochromeLib.h"
#include "fonctions basiques.h"
#include "Ether.h"


void utilisation_pouvoir(Map *map,General *general,Pouvoir *pouvoirs_choisis[6])
{
	char i,j=-1;
	Pouvoir *pouvoir;
	
	do
	{
		i=categorie_pouvoir();
		if(i>-1)j=i;
	}while(j>-1 && i>-1);

	if(j>=0)
	{
		if(j!=3)general->etape=0;
		pouvoir=pouvoirs_choisis[j];
		if(pouvoir==NULL)return;
		
		if(pouvoir->etat==INACTIF)
		{
			pouvoir->etat=UTILISE;
			effet_immediat(map,general,pouvoir);
		}
	}
}

void effet_immediat(Map *map,General *general,Pouvoir *pouvoir)
{
	char i,j,k,x,y,distance_x,distance_y,distance1,distance2,mouvement,camp_max;
	Etre *etre,*cible,*tableau[40];
	Obstacle obstacle;
	Bool echange;

	switch(pouvoir->id)
	{
		case ECRAN_FUMEE:
			map->x_origine=general->x;
			map->y_origine=general->y;
			map->propagation=0;
			map->compteur=VITESSE_MAX;
		Bcase(IMPULSION)
			//Tri à bulles des etres par ordre de distance décroissant :
			for(i=1;i<map->nombre_etres+3;i++)tableau[i-1]=&(map->etres[i]);
			
			do
			{
				echange=FAUX;
				for(i=0;i<map->nombre_etres+1;i++)
				{
					distance1=DISTANCE(tableau[i]->x,tableau[i]->y,general->x,general->y);
					distance2=DISTANCE(tableau[i+1]->x,tableau[i+1]->y,general->x,general->y);
					if(distance2>distance1)
					{
						etre=tableau[i];
						tableau[i]=tableau[i+1];
						tableau[i+1]=etre;
						echange=VRAI;
					}
				}
			}while(echange);
			
			for(i=0;i<map->nombre_etres+2;i++)
			{
				etre=tableau[i];
				if(DISTANCE(general->x,general->y,etre->x,etre->y)<=3 && etre->vivant && i!=2 && etre->x!=-1)
				{	
					infliger_degats(etre,25);
					
					distance_x=ABS(etre->x-general->x);
					distance_y=ABS(etre->y-general->y);
					
					if(distance_x>distance_y)
					{
						if(etre->x < general->x)mouvement=4;
						else mouvement=2;
					}
					else
					{
						if(etre->y < general->y)mouvement=1;
						else mouvement=3;
					}
					
					for(j=0;j<3;j++)
					{
						MAP(etre->x,etre->y)=RIEN;
						deplacement(map,mouvement,&etre->x,&etre->y,&distance_x,etre->dessous,FAUX);
						if(MAP(etre->x,etre->y))etre->dessous=VRAI;
						else etre->dessous=FAUX;
					}
					
					if(etre->type>=FANATIQUE)MAP(etre->x,etre->y)=ETRE;
					else MAP(etre->x,etre->y)=LEURRE;
					
					/*L'envoi de distance_x pour le paramètre direction est volontaire : si on avait envoyé le bon paramètre,
					il aurait été modifie*/
					
					if(etre->camp)general->alerte=VRAI;
				}
			}
		Bcase(FUGACITE)	
			general->fugace=VRAI;
		Bcase(VAPORISATION)
			general->vapeur=VRAI;
			MAP(general->x,general->y)=RIEN;
		Bcase(FURTIVITE)
			general->furtif=VRAI;
			general->alerte=FAUX;
		Bcase(VEHEMENCE)
			general->vehemence=VRAI;
		Bcase(BOUCLIER)
			general->bouclier=VRAI;
		Bcase(REGENERATION)
			general->regeneration=VRAI;
		Bcase(REMPART_ENERGIE)
			etre=&map->etres[2];
			coordonnees_devant(general->x,general->y,general->direction,&i,&j);
			if(MAP(i,j) || etre->x!=-1)pouvoir->etat=INACTIF;
			else
			{
				MAP(i,j)=REMPART;
				etre->x=i;
				etre->y=j;
			}
		Bcase(CREATION_LEURRE)
			etre=&map->etres[1];
			coordonnees_devant(general->x,general->y,general->direction,&i,&j);
			if(MAP(i,j) || etre->x!=-1)pouvoir->etat=INACTIF;
			else
			{
				MAP(i,j)=LEURRE;
				etre->x=i;
				etre->y=j;
				etre->dessous=FAUX;
			}
		Bcase(TOURBILLON_CHAOTIQUE)
			for(i=0;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				if(etre->x!=-1 && etre->vivant)
				{
					if(etre->dessous)
					{
						MAP(etre->x,etre->y)=LARME;
						etre->dessous=FAUX;
					}
					else MAP(etre->x,etre->y)=RIEN;
				}
			}
			
			for(i=0;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				if(etre->x!=-1 && etre->vivant)
				{
					do
					{
						etre->x=alea(0,LARGEUR-1);
						etre->y=alea(0,HAUTEUR-1);
					}while(MAP(etre->x,etre->y));
					
					obstacle=RIEN;
					if(etre->type >= FANATIQUE)obstacle=ETRE;
					if(etre->type==TYPE_REMPART)obstacle=REMPART;
					if(etre->type==TYPE_LEURRE)obstacle=LEURRE;
					if(!etre->type && !general->vapeur)obstacle=PERSONNAGE;
				
					etre->direction=alea(1,4);
					
					if(obstacle)MAP(etre->x,etre->y)=obstacle;
				}
			}

			general->x=map->etres[0].x;
			general->y=map->etres[0].y;
			general->direction=map->etres[0].direction;
			
			general->alerte=VRAI;
		Bcase(ETOURDISSEMENT)
			for(i=3;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				if(etre->vivant)etre->etourdissement=16*5;	//16 : vitesse moyenne
				general->alerte=VRAI;
			}
		Bcase(DEMENCE)
			cible=NULL;
			camp_max=0;
			
			for(i=3;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				if(etre->camp > camp_max)camp_max=etre->camp;
				
				if(etre->vivant)
				{
					k=0;
					if(general->direction&1)
					{
						for(j=general->y;MAP(general->x,j)<10 || j==general->y;j+=1-2*(general->direction==1));
						if(etre->x==general->x && etre->y==j)k=1;
					}
					else
					{
						for(j=general->x;MAP(j,general->y)<10 || j==general->x;j+=1-2*(general->direction==4));
						if(etre->x==j && etre->y==general->y)k=1;
					}
					
					if(k)cible=etre;
				}
			}
			
			if(cible)
			{
				cible->camp=camp_max+1;
				cible->cible_mouvement=-1;
			}
			else pouvoir->etat=INACTIF;
		Bcase(CONFUSION)
			for(i=3;i<map->nombre_etres;i++)if(map->etres[i].vivant)map->etres[i].confus=VRAI;
		break;
	}
	
	if(pouvoir->type_energie==RESIDUELLE)
	{
		j=0;
		for(i=0;i<map->nombre_sources;i++)j+=(map->energie[i*2]!=-1 && (map->energie[i*2]!=general->x_source || map->energie[i*2+1]!=general->y_source));
	
		if(j)
		{
			general->etape=1;
			do
			{
				i=alea(0,map->nombre_sources-1);	
			}while(map->energie[2*i]==-1 || (map->energie[i*2]==general->x_source && map->energie[i*2+1]==general->y_source));
			
			general->x_source=map->energie[i*2];
			general->y_source=map->energie[2*i+1];
			general->zoom=FAUX;
		}
		
		pouvoir->etat=INACTIF;
	}
}

void effet_continu(Map *map,General *general,Pouvoir *pouvoir,char compteur)
{
	char i,distance_max,distance;
	Etre *etre;

	if(pouvoir==NULL)return;
	if(pouvoir->etat!=UTILISE && (pouvoir->type_energie!=RESIDUELLE || general->etape!=1 || !SHIFT))return;
	
	switch(pouvoir->id)
	{
		case AURA_ENTRAVE:
			for(i=3;i<map->nombre_etres;i++)
			{
				etre=&(map->etres[i]);
				if(DISTANCE(general->x,general->y,etre->x,etre->y)<=3 && etre->vivant)etre->entrave=VRAI;
			}
		Bcase(ECRAN_FUMEE)			
			if(map->compteur==VITESSE_MAX)
			{
				memset(map->carte_fumee,0,LARGEUR*HAUTEUR*sizeof(char));
				propagation_fumee(map,map->x_origine,map->y_origine,-1,map->propagation,1);
				map->compteur=0;
				map->propagation++;
			}
			map->compteur++;
		Bcase(FURTIVITE)
			general->alternance=!general->alternance;
		Bcase(REGENERATION)
			if(!compteur)
			{
				general->vie+=3;
				if(general->vie > VIE_MAX)general->vie=VIE_MAX;
			}
		Bcase(DECHARGE_ENERGIE)
			general->cible=NULL;
			distance_max=100;
			
			for(i=3;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				distance=DISTANCE(etre->x,etre->y,general->x_source,general->y_source);
				
				if(distance<distance_max && visible(etre->x,etre->y,general->x_source,general->y_source,0,*map) && etre->vivant)
				{
					distance_max=distance;
					general->cible=etre;
				}
			}
			
			if(general->cible)
			{
				infliger_degats(general->cible,distance_max ? 300/distance_max : 400);
				general->alerte=VRAI;
			}
		Bcase(DEFLAGRATION)
			for(i=1;i<map->nombre_etres;i++)
			{
				etre=&map->etres[i];
				distance=DISTANCE(etre->x,etre->y,general->x_source,general->y_source);
				if(distance<=3 && etre->vivant)infliger_degats(etre,distance ? 150/distance : 200);
			}
			
			distance=DISTANCE(general->x,general->y,general->x_source,general->y_source);
			if(distance<=3)
			{
				general->vie-=distance ? 150/distance : 200;
				general->blessure=8;
			}
			
			for(i=0;i<map->nombre_sources;i++)if(map->energie[2*i]==general->x_source && map->energie[2*i+1]==general->y_source)map->energie[2*i]=-1;
			general->alerte=VRAI;
		Bcase(RESSOURCEMENT)
			distance=DISTANCE(general->x,general->y,general->x_source,general->y_source);
			general->vie+=distance ? 150/distance : 200;
			if(general->vie > VIE_MAX)general->vie=VIE_MAX;
		break;
	}
	
	if(pouvoir->type_energie==RESIDUELLE)
	{
		pouvoir->etat=RECHARGEMENT;
		general->etape=18;
		while(SHIFT);
	}
}

void effet_final(Pouvoir *pouvoir,General *general,Map *map)
{
	char i;

	switch(pouvoir->id)
	{
		case ECRAN_FUMEE:
			map->dispersion=VRAI;
			map->propagation=0;
			memcpy(map->copie_carte_fumee,map->carte_fumee,LARGEUR*HAUTEUR*sizeof(char));
		Bcase(FUGACITE)
			general->fugace=FAUX;
		Bcase(VAPORISATION)
			if(MAP(general->x,general->y)<10)general->vapeur=FAUX;
			else
			{
				pouvoir->utilisation=1;
				pouvoir->etat=UTILISE;
			}
		Bcase(FURTIVITE)
			general->furtif=FAUX;
			general->alternance=VRAI;
		Bcase(VEHEMENCE)
			general->vehemence=FAUX;
		Bcase(BOUCLIER)
			general->bouclier=FAUX;
		Bcase(REGENERATION)
			general->regeneration=FAUX;
		Bcase(CONFUSION)
			for(i=3;i<map->nombre_etres;i++)if(map->etres[i].vivant)map->etres[i].confus=FAUX;
		break;
	}
}

void gestion_pouvoir(Pouvoir *pouvoir,General *general,Map *map)
{
	if(pouvoir)
	{
		if(pouvoir->etat==RECHARGEMENT)
		{
			if(pouvoir->rechargement==pouvoir->temps_rechargement)
			{
				pouvoir->rechargement=0;
				pouvoir->etat=INACTIF;
			}
			else pouvoir->rechargement++;
		}
		
		if(pouvoir->etat==UTILISE)
		{
			if(!pouvoir->utilisation)
			{
				pouvoir->utilisation=pouvoir->temps_utilisation;
				pouvoir->etat=RECHARGEMENT;
				effet_final(pouvoir,general,map);
			}
			else pouvoir->utilisation--;
		}
	}
}

char propagation_fumee(Map *map,char x,char y,char propagation,char propagation_max,char etat_case)
{
	if((MAP(x,y)>=10 && MAP(x,y)<100) || MAP(x,y)>=200 || MAP_FUMEE(x,y)==etat_case)return propagation;
	
	
	MAP_FUMEE(x,y)=etat_case;
	
	propagation++;
	if(propagation==propagation_max)
	{
		propagation--;
		return propagation;
	}
	
	propagation=propagation_fumee(map,x+1,y,propagation,propagation_max,etat_case);
	propagation=propagation_fumee(map,x-1,y,propagation,propagation_max,etat_case);
	propagation=propagation_fumee(map,x,y+1,propagation,propagation_max,etat_case);
	propagation=propagation_fumee(map,x,y-1,propagation,propagation_max,etat_case);
	
	propagation--;
	return propagation;
}

void dispersion_fumee(Map *map)
{
	char i,j,k;
	
	if(map->compteur==VITESSE_MAX)
	{
		memcpy(map->carte_fumee,map->copie_carte_fumee,HAUTEUR*LARGEUR*sizeof(char));
		propagation_fumee(map,map->x_origine,map->y_origine,-1,map->propagation,0);
		map->compteur=0;
		map->propagation++;
	}
	map->compteur++;
	
	k=0;
	for(i=0;i<LARGEUR;i++)for(j=0;j<HAUTEUR;j++)k+=MAP_FUMEE(i,j);
	if(!k)map->dispersion=FAUX;
}


char categorie_pouvoir()
{
	//returne la catégorie de pouvoirs qui correspond à la touche pressée
	char i=-1;
	if(IsKeyDown(KEY_CTRL_F1))i=0;
	if(IsKeyDown(KEY_CTRL_F2))i=1;
	if(IsKeyDown(KEY_CTRL_F3))i=2;
	if(IsKeyDown(KEY_CTRL_F4))i=3;
	if(IsKeyDown(KEY_CTRL_F5))i=4;
	if(IsKeyDown(KEY_CTRL_F6))i=5;
	
	return i;
}
