#include <stdio.h>
#include <stdlib.h>
#include "MonochromeLib.h"			//Penser à décommenter les fonctions ML_bmp_and, ML_bmp_and_cl et ML_pixel

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

int RTC_getTicks()
{
    return (*SysCall)(0, 0, 0, 0, 0x3B);
}

int alea(int min,int max)
{
	return rand()%(max-min+1)+min;
}

void cache(char x, char y, char largeur, char hauteur)
{
	char largeur2=largeur;
	const unsigned char *bmp;
	for(;largeur2%8;largeur2++);
	
	bmp=calloc((largeur2/8)*hauteur,sizeof(char));
	ML_bmp_and(bmp,x,y,largeur,hauteur);
	free(bmp);
}

void cache_cl(char x, char y, char largeur, char hauteur)
{
	char largeur2=largeur;
	const unsigned char *bmp;
	for(;largeur2%8;largeur2++);
	
	bmp=calloc((largeur2/8)*hauteur,sizeof(char));
	ML_bmp_and_cl(bmp,x,y,largeur,hauteur);
	free(bmp);
}

void setFps(int fpsWish)
{
	static unsigned int fps=0,fps_count=0;
	do
	{
		fps=RTC_getTicks();
		Sleep(1);
	}
	while(fps<fps_count+fpsWish);
	fps_count=RTC_getTicks();
}

int abs(int nombre)
{
    if(nombre<0)return -nombre;
    return nombre;
}

char *convert(char chaine[12],int nombre)
{
	int i, length=0;
	chaine[0]='0';
	chaine[1]=0;
	
	
    if(nombre)
    {
        if(nombre<0)
        {
            length++;
			chaine[0]='-';
            nombre*=-1;
        }
        for(i=nombre;i;i/=10)length++;
        chaine[length] = 0;
        for(;nombre;nombre/=10)chaine[--length] = nombre%10+'0';
    }
	
	return chaine;
}

int taille_pixels(char *texte)
{
	//Caractère de 1 pixel de large : i
	//Caractères de 4 pixels de large : n,K,r
	//Caractères de 5 pixels de large : m,M,N,Q,w,W

	short caracteres[]={'i',0,-2,'n','K','r',0,1,'m','M','N','Q','w','W',0,2,'!'};
	int taille_texte=-1;
	char i,j;
	for(i=0;texte[i];i++)
	{
		j=0;
		taille_texte+=4;
		while(caracteres[j]!='!')
		{
			if(texte[i]==caracteres[j])
			{
				while(caracteres[j])j++;
				j++;
				taille_texte+=caracteres[j];
			}
			j++;
			if(!caracteres[j])j+=2;
		}
	}
	
	return taille_texte;
}

int pow_int(int nombre,int puissance)
{
	int i;
	for(i=1;i<puissance;i++)nombre*=nombre;
	
	if(puissance)return nombre;
	return 0;
}

void inversion_ecran()
{
	unsigned char i,j;
	for(i=0;i<=127;i++)for(j=0;j<=63;j++)ML_pixel(i,j,ML_XOR);
}

void memswap(void *pointeur1,void *pointeur2,size_t taille)
{
	void *intermediaire=malloc(taille);
	memcpy(intermediaire,pointeur1,taille);
	memcpy(pointeur1,pointeur2,taille);
	memcpy(pointeur2,intermediaire,taille);
	free(intermediaire);
}
